/*     */ package com.jaspersoft.jasperserver.irplugin;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.irplugin.gui.CheckUpdateDialog;
/*     */ import com.jaspersoft.jasperserver.irplugin.gui.RepositoryExplorer;
/*     */ import it.businesslogic.ireport.gui.MainFrame;
/*     */ import it.businesslogic.ireport.gui.sheet.Tag;
/*     */ import it.businesslogic.ireport.plugin.IReportPlugin;
/*     */ import it.businesslogic.ireport.util.I18n;
/*     */ import it.businesslogic.ireport.util.LanguageChangedEvent;
/*     */ import it.businesslogic.ireport.util.LanguageChangedListener;
/*     */ import java.awt.Component;
/*     */ import java.awt.Dialog;
/*     */ import java.io.File;
/*     */ import java.io.FileInputStream;
/*     */ import java.io.FileOutputStream;
/*     */ import java.io.InputStream;
/*     */ import java.io.PrintStream;
/*     */ import java.text.Format;
/*     */ import java.text.MessageFormat;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Arrays;
/*     */ import java.util.Comparator;
/*     */ import java.util.Date;
/*     */ import java.util.Hashtable;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import java.util.Locale;
/*     */ import java.util.MissingResourceException;
/*     */ import java.util.Properties;
/*     */ import java.util.ResourceBundle;
/*     */ import java.util.Set;
/*     */ import javax.swing.JOptionPane;
/*     */ import javax.swing.SwingUtilities;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class IRPlugin
/*     */   extends IReportPlugin
/*     */ {
/*  53 */   public static String configFileName = "jasperserverplugin.xml";
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*  58 */   public static String REQUIRED_VERSION = "";
/*  59 */   public static String CURRENT_VERSION = "";
/*     */   
/*     */   public static final String PROPERTY_CHECK_FOR_UPDATE = "PROPERTY_CHECK_FOR_UPDATE";
/*  62 */   private boolean viewVisible = false;
/*     */   
/*  64 */   private boolean firstTime = true;
/*     */   
/*     */ 
/*     */   public static final String localPackageName = "com/jaspersoft/jasperserver/irplugin/locale/";
/*     */   
/*     */   public static final String baseName = "irplugin";
/*     */   
/*  71 */   private static ResourceBundle oLanguage = null;
/*  72 */   private static Locale pluginLocale = null;
/*     */   
/*  74 */   private static IRPlugin mainInstance = null;
/*     */   
/*  76 */   public static IRPlugin getMainInstance() { return mainInstance; }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  83 */   private List jServers = new ArrayList();
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*  88 */   private Properties properties = new Properties();
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  97 */   private Properties brandingProperties = new Properties();
/*     */   
/*  99 */   private RepositoryExplorer repositoryExplorer = null;
/* 100 */   boolean firstCall = true;
/*     */   
/*     */   public IRPlugin()
/*     */   {
/* 104 */     mainInstance = this;
/*     */   }
/*     */   
/*     */ 
/*     */   public void call()
/*     */   {
/* 110 */     if (getRepositoryExplorer() == null)
/*     */     {
/* 112 */       loadConfiguration();
/* 113 */       setRepositoryExplorer(new RepositoryExplorer(this));
/*     */     }
/*     */     
/* 116 */     MainFrame.getMainInstance(); if (MainFrame.constTitle.compareTo("iReport 1.2.6 ") < 0)
/*     */     {
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 125 */       SwingUtilities.invokeLater(new Runnable()
/*     */       {
/*     */         public void run()
/*     */         {
/* 129 */           JOptionPane.showMessageDialog(MainFrame.getMainInstance(), IRPlugin.getFormattedString("messages.requirements", "JasperReports plugin requires iReport {0} or above!", new Object[] { "1.2.6" }));
/*     */         }
/* 131 */       });
/* 132 */       return;
/*     */     }
/*     */     
/*     */ 
/* 136 */     if ((!isViewVisible()) || (!getRepositoryExplorer().isShowing()))
/*     */     {
/* 138 */       DockingUtil.installUI(getRepositoryExplorer());
/*     */     }
/*     */     
/*     */ 
/* 142 */     if ((!this.firstTime) || (getProperties().getProperty("PROPERTY_CHECK_FOR_UPDATE", "true").equals("true")))
/*     */     {
/* 144 */       SwingUtilities.invokeLater(new Runnable()
/*     */       {
/*     */         public void run()
/*     */         {
/*     */           try
/*     */           {
/* 150 */             UpgradeSearch us = new UpgradeSearch();
/* 151 */             Thread t = new Thread(us);
/* 152 */             t.start();
/*     */           } catch (Throwable ex) {
/* 154 */             ex.printStackTrace();
/*     */           }
/*     */         }
/*     */       });
/*     */     }
/*     */     
/* 160 */     if (!this.firstTime)
/*     */     {
/* 162 */       pluginLocale = I18n.getCurrentLocale();
/*     */       
/*     */ 
/* 165 */       I18n.addOnLanguageChangedListener(new LanguageChangedListener()
/*     */       {
/*     */         public void languageChanged(LanguageChangedEvent languageChangedEvent) {
/* 168 */           for (int i = 0; i < IRPlugin.this.getJServers().size(); i++)
/*     */           {
/* 170 */             ((JServer)IRPlugin.this.getJServers().get(i)).setLocale(languageChangedEvent.getLocale().getLanguage());
/*     */           }
/*     */         }
/*     */       });
/*     */     }
/* 175 */     this.firstTime = false;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public void configure()
/*     */   {
/* 183 */     CheckUpdateDialog cup = new CheckUpdateDialog(getMainFrame(), true);
/* 184 */     cup.setVisible(true);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void loadConfiguration()
/*     */   {
/* 195 */     setProperties(new Properties());
/* 196 */     File configFile = new File(MainFrame.IREPORT_USER_HOME_DIR, configFileName);
/*     */     try
/*     */     {
/* 199 */       if (configFile.exists())
/*     */       {
/* 201 */         getProperties().loadFromXML(new FileInputStream(configFile));
/*     */       }
/*     */     }
/*     */     catch (Exception ex) {
/* 205 */       ex.printStackTrace();
/*     */     }
/*     */     
/* 208 */     Properties props = getProperties();
/* 209 */     for (int i = 0; props.getProperty("server." + i + ".name") != null; i++)
/*     */     {
/* 211 */       JServer server = new JServer();
/* 212 */       server.setName(props.getProperty("server." + i + ".name"));
/* 213 */       server.setUrl(props.getProperty("server." + i + ".url"));
/* 214 */       server.setUsername(props.getProperty("server." + i + ".username"));
/* 215 */       server.setPassword(props.getProperty("server." + i + ".password"));
/* 216 */       server.setLocale(I18n.getCurrentLocale().getLanguage());
/* 217 */       getJServers().add(server);
/*     */     }
/*     */     
/*     */ 
/*     */ 
/* 222 */     addProperties("/com/jaspersoft/jasperserver/irplugin/default.jasperserver_irplugin.properties", getBrandingProperties());
/* 223 */     addProperties("/com/jaspersoft/jasperserver/irplugin/jasperserver_irplugin.properties", getBrandingProperties());
/*     */     
/* 225 */     System.out.println(getBrandingProperties() + "");
/*     */     
/* 227 */     REQUIRED_VERSION = getBrandingProperties().getProperty("irplugin.server.required.version");
/* 228 */     CURRENT_VERSION = getBrandingProperties().getProperty("irplugin.version");
/*     */   }
/*     */   
/*     */   private void addProperties(String resourceUri, Properties props)
/*     */   {
/*     */     try
/*     */     {
/* 235 */       InputStream is = getClass().getResourceAsStream(resourceUri);
/* 236 */       if (is == null) return;
/* 237 */       props.load(is);
/*     */     }
/*     */     catch (Exception ex) {
/* 240 */       ex.printStackTrace();
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean saveConfiguration()
/*     */   {
/* 249 */     File dir = new File(MainFrame.IREPORT_USER_HOME_DIR);
/*     */     
/*     */ 
/*     */ 
/*     */ 
/* 254 */     for (int i = 0; getProperties().getProperty("server." + i + ".name") != null; i++)
/*     */     {
/* 256 */       getProperties().remove("server." + i + ".name");
/* 257 */       getProperties().remove("server." + i + ".url");
/* 258 */       getProperties().remove("server." + i + ".username");
/* 259 */       getProperties().remove("server." + i + ".password");
/*     */     }
/*     */     
/* 262 */     for (int i = 0; i < getJServers().size(); i++)
/*     */     {
/* 264 */       JServer server = (JServer)getJServers().get(i);
/* 265 */       getProperties().setProperty("server." + i + ".name", server.getName());
/* 266 */       getProperties().setProperty("server." + i + ".url", server.getUrl());
/* 267 */       getProperties().setProperty("server." + i + ".username", server.getUsername());
/* 268 */       getProperties().setProperty("server." + i + ".password", server.getPassword());
/*     */     }
/*     */     try
/*     */     {
/* 272 */       if (dir.exists()) {
/* 273 */         if (!dir.isDirectory()) {
/* 274 */           JOptionPane.showMessageDialog(getMainFrame(), getFormattedString("messages.error.1", "{0}\nis not a directory!\nPlease rename this file and retry to save config!", new Object[] { "" + dir.getPath() }), "", 0);
/*     */           
/*     */ 
/*     */ 
/*     */ 
/* 279 */           return false;
/*     */         }
/*     */       }
/*     */       else {
/* 283 */         dir.mkdirs();
/*     */       }
/*     */       
/* 286 */       File configFile = new File(dir, configFileName);
/* 287 */       getProperties().storeToXML(new FileOutputStream(configFile), "JasperServer Plugin configuration file\n (c) 2006 by JasperSoft");
/*     */       
/* 289 */       return true;
/*     */     } catch (Exception ex) {
/* 291 */       JOptionPane.showMessageDialog(getMainFrame(), getFormattedString("messages.error.2", "An error is occurred saving Plugin config:\n{0}\nPlease try to save config again!", new Object[] { "" + ex.getMessage() }), "", 0);
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/* 297 */     return false;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public Properties getProperties()
/*     */   {
/* 305 */     return this.properties;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void setProperties(Properties properties)
/*     */   {
/* 312 */     this.properties = properties;
/*     */   }
/*     */   
/*     */   public List getJServers() {
/* 316 */     return this.jServers;
/*     */   }
/*     */   
/*     */   public void setJServers(List jServers) {
/* 320 */     this.jServers = jServers;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static String createTmpFileName(String filePrefix, String fileExtension)
/*     */   {
/* 338 */     if (filePrefix == null) filePrefix = ""; else
/* 339 */       filePrefix = filePrefix + "_";
/* 340 */     if ((fileExtension != null) && (!fileExtension.startsWith(".")))
/*     */     {
/* 342 */       fileExtension = "." + fileExtension;
/*     */     }
/*     */     
/* 345 */     if (fileExtension == null) { fileExtension = ".tmp";
/*     */     }
/* 347 */     MainFrame.getMainInstance();String tmpDirectory = MainFrame.IREPORT_USER_HOME_DIR;
/* 348 */     tmpDirectory = tmpDirectory + File.separator + "jstmp";
/*     */     
/* 350 */     File tmpDirectoryFile = new File(tmpDirectory);
/* 351 */     if (!tmpDirectoryFile.exists())
/*     */     {
/* 353 */       tmpDirectoryFile.mkdirs();
/*     */     }
/*     */     
/* 356 */     return tmpDirectoryFile + File.separator + filePrefix + new Date().getTime() + fileExtension;
/*     */   }
/*     */   
/*     */   public RepositoryExplorer getRepositoryExplorer()
/*     */   {
/* 361 */     return this.repositoryExplorer;
/*     */   }
/*     */   
/*     */   public void setRepositoryExplorer(RepositoryExplorer repositoryExplorer) {
/* 365 */     this.repositoryExplorer = repositoryExplorer;
/*     */   }
/*     */   
/*     */   public boolean isViewVisible() {
/* 369 */     return this.viewVisible;
/*     */   }
/*     */   
/*     */   public void setViewVisible(boolean viewVisible) {
/* 373 */     this.viewVisible = viewVisible;
/*     */   }
/*     */   
/*     */ 
/*     */   public static String getString(String cID, String defaultValue)
/*     */   {
/* 379 */     return getString(cID, I18n.getCurrentLocale(), defaultValue);
/*     */   }
/*     */   
/*     */   public static String getFormattedString(String cID, String defaultValue, Object[] args)
/*     */   {
/* 384 */     String pattern = getString(cID, I18n.getCurrentLocale(), defaultValue);
/* 385 */     MessageFormat mf = new MessageFormat(pattern, I18n.getCurrentLocale());
/* 386 */     return mf.format(args);
/*     */   }
/*     */   
/*     */   private static String getString(String cID, Locale currentLocale, String defaultValue)
/*     */   {
/*     */     try
/*     */     {
/* 393 */       if ((oLanguage == null) || (!pluginLocale.equals(currentLocale)))
/*     */       {
/* 395 */         pluginLocale = currentLocale;
/* 396 */         oLanguage = ResourceBundle.getBundle("com/jaspersoft/jasperserver/irplugin/locale/irplugin", currentLocale);
/*     */       }
/*     */       
/* 399 */       String s = oLanguage.getString(cID);
/* 400 */       if ((s != null) && (s.startsWith("${")) && (s.endsWith("}")))
/*     */       {
/* 402 */         String newKey = s.substring(2, s.length() - 1);
/* 403 */         if (newKey.length() > 0)
/*     */         {
/* 405 */           return I18n.getString(newKey, defaultValue);
/*     */         }
/*     */       }
/*     */       
/* 409 */       return s;
/*     */     }
/*     */     catch (MissingResourceException ex)
/*     */     {
/* 413 */       System.out.println("IRPlugin: Can't find the translation for key = " + cID + ": using default (" + defaultValue + ")");
/*     */     }
/*     */     catch (Exception ex)
/*     */     {
/* 417 */       System.out.println("IRPlugin: Exception loading cID = " + cID + ": " + ex.getMessage());
/*     */     }
/* 419 */     return defaultValue;
/*     */   }
/*     */   
/*     */   public static ResourceBundle getOLanguage() {
/* 423 */     return oLanguage;
/*     */   }
/*     */   
/*     */   public static void setOLanguage(ResourceBundle aOLanguage) {
/* 427 */     oLanguage = aOLanguage;
/*     */   }
/*     */   
/*     */   public Properties getBrandingProperties() {
/* 431 */     return this.brandingProperties;
/*     */   }
/*     */   
/*     */   public void setBrandingProperties(Properties brandingProperties) {
/* 435 */     this.brandingProperties = brandingProperties;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public List getSupportedQueryLanguages()
/*     */   {
/* 443 */     Iterator iter = getBrandingProperties().keySet().iterator();
/* 444 */     ArrayList list = new ArrayList();
/*     */     
/* 446 */     while (iter.hasNext())
/*     */     {
/* 448 */       String key = "" + iter.next();
/* 449 */       if ((key.startsWith("query.language.")) && (!key.endsWith(".enabled")))
/*     */       {
/* 451 */         String language = key.substring(15);
/* 452 */         if (getBrandingProperties().getProperty(key + ".enabled", "true").equals("true"))
/*     */         {
/* 454 */           list.add(new Tag(language, getBrandingProperties().getProperty(key)));
/*     */         }
/*     */       }
/*     */     }
/*     */     
/*     */ 
/* 460 */     Object[] tobeordered = list.toArray();
/* 461 */     Arrays.sort(tobeordered, new Comparator()
/*     */     {
/*     */       public int compare(Object o1, Object o2) {
/* 464 */         return ((Tag)o1).getName().compareTo(((Tag)o2).getName());
/*     */       }
/*     */       
/* 467 */       public boolean equals(Object obj) { return (obj != null) && (equals(obj));
/*     */       }
/*     */ 
/* 470 */     });
/* 471 */     list.clear();
/* 472 */     for (int i = 0; i < tobeordered.length; i++) { list.add(tobeordered[i]);
/*     */     }
/* 474 */     return list;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jasperserver-ireport-plugin-2.0.1.jar!\com\jaspersoft\jasperserver\irplugin\IRPlugin.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */