/*     */ package com.jaspersoft.jasperserver.irplugin.gui.jrxmlvalidator;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.ResourceDescriptor;
/*     */ import com.jaspersoft.jasperserver.irplugin.IRPlugin;
/*     */ import com.jaspersoft.jasperserver.irplugin.JServer;
/*     */ import com.jaspersoft.jasperserver.irplugin.RepositoryFolder;
/*     */ import com.jaspersoft.jasperserver.irplugin.wsclient.WSClient;
/*     */ import it.businesslogic.ireport.ImageReportElement;
/*     */ import it.businesslogic.ireport.Report;
/*     */ import it.businesslogic.ireport.gui.MainFrame;
/*     */ import it.businesslogic.ireport.util.Misc;
/*     */ import java.awt.Container;
/*     */ import java.awt.Dialog;
/*     */ import java.awt.Dimension;
/*     */ import java.awt.EventQueue;
/*     */ import java.awt.Frame;
/*     */ import java.awt.GridBagConstraints;
/*     */ import java.awt.GridBagLayout;
/*     */ import java.awt.Image;
/*     */ import java.awt.Insets;
/*     */ import java.awt.Window;
/*     */ import java.io.File;
/*     */ import java.util.List;
/*     */ import javax.swing.JComponent;
/*     */ import javax.swing.JDialog;
/*     */ import javax.swing.JFrame;
/*     */ import javax.swing.JLabel;
/*     */ import javax.swing.JOptionPane;
/*     */ import javax.swing.JProgressBar;
/*     */ import javax.swing.SwingUtilities;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class UploadResourcesDialog
/*     */   extends JDialog
/*     */   implements Runnable
/*     */ {
/*  40 */   private JrxmlValidationDialog validationDialog = null;
/*  41 */   private List resourceItems = null;
/*     */   private JLabel jLabel;
/*     */   private JProgressBar jProgressBar1;
/*     */   
/*  45 */   public UploadResourcesDialog(Frame parent, boolean modal) { super(parent, modal);
/*  46 */     initComponents();
/*     */     
/*  48 */     this.jProgressBar1.setMinimum(0);
/*  49 */     this.jProgressBar1.setMaximum(100);
/*  50 */     this.jProgressBar1.setValue(0);
/*     */     
/*  52 */     Misc.centerFrame(this);
/*     */   }
/*     */   
/*     */   public void setLabel(String label)
/*     */   {
/*  57 */     this.jLabel.setText(label);
/*     */   }
/*     */   
/*     */   public void setCompletation(int d)
/*     */   {
/*  62 */     this.jProgressBar1.setValue(d);
/*     */   }
/*     */   
/*     */ 
/*     */   public void startProcessing()
/*     */   {
/*  68 */     Thread t = new Thread(this);
/*  69 */     t.start();
/*     */   }
/*     */   
/*     */   public void run()
/*     */   {
/*  74 */     this.jProgressBar1.setValue(0);
/*     */     
/*  76 */     this.jLabel.setText(IRPlugin.getString("uploadResourcesDialog.adaptingJRXML", "Adapting JRXML source..."));
/*  77 */     JrxmlValidationDialog vd = getValidationDialog();
/*     */     
/*  79 */     this.jProgressBar1.setValue(5);
/*     */     
/*     */     try
/*     */     {
/*  83 */       for (int i = 0; i < this.resourceItems.size(); i++)
/*     */       {
/*  85 */         this.jProgressBar1.setValue(15);
/*  86 */         ImageElementValidationItem iev = (ImageElementValidationItem)this.resourceItems.get(i);
/*  87 */         Image img = iev.getReportElement().getImg();
/*  88 */         iev.getReportElement().setImageExpression("\"" + iev.getProposedExpression() + "\"");
/*  89 */         iev.getReportElement().setImg(img);
/*     */         
/*  91 */         this.jProgressBar1.setValue(20);
/*  92 */         ResourceDescriptor newDescriptor = new ResourceDescriptor();
/*  93 */         newDescriptor.setWsType("img");
/*  94 */         newDescriptor.setParentFolder(vd.getReportUnit() != null ? vd.getReportUnit().getDescriptor().getUriString() : "/");
/*  95 */         newDescriptor.setName(iev.getResourceName());
/*  96 */         newDescriptor.setLabel(iev.getResourceName());
/*  97 */         newDescriptor.setIsNew(true);
/*  98 */         newDescriptor.setHasData(true);
/*     */         
/* 100 */         this.jLabel.setText(IRPlugin.getFormattedString("uploadResourcesDialog.uploadingResource", "Uploading {0}", new Object[] { iev.getOriginalFileName().getName() }));
/*     */         
/* 102 */         vd.getServer().getWSClient().modifyReportUnitResource(vd.getReportUnit() != null ? vd.getReportUnit().getDescriptor().getUriString() : null, newDescriptor, iev.getOriginalFileName());
/*     */         
/*     */ 
/*     */ 
/* 106 */         this.jProgressBar1.setValue((int)(100.0D / i));
/*     */       }
/*     */       
/* 109 */       vd.getReport().saveXMLFile();
/*     */       
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */       try
/*     */       {
/* 138 */         SwingUtilities.invokeAndWait(new Runnable()
/*     */         {
/*     */           public void run() {
/* 141 */             UploadResourcesDialog.this.setVisible(false);
/* 142 */             UploadResourcesDialog.this.dispose();
/*     */           }
/*     */         });
/*     */       }
/*     */       catch (Exception ex3) {}
/*     */       Exception ex2;
/* 148 */       getValidationDialog().elaborationFinished(true);
/*     */     }
/*     */     catch (Exception ex)
/*     */     {
/* 113 */       ex2 = ex;
/* 114 */       ex.printStackTrace();
/*     */       try {
/* 116 */         SwingUtilities.invokeAndWait(new Runnable() {
/*     */           private final Exception val$ex2;
/*     */           
/*     */           public void run() {
/* 120 */             UploadResourcesDialog.this.setVisible(false);
/* 121 */             UploadResourcesDialog.this.dispose();
/*     */             
/* 123 */             JOptionPane.showMessageDialog(MainFrame.getMainInstance(), IRPlugin.getFormattedString("uploadResourcesDialog.uploadingResourceError", "An error occurred during resource upload:\n{0}", new Object[] { this.val$ex2.getMessage() }), "Error", 0);
/*     */           }
/*     */         });
/*     */       }
/*     */       catch (Exception ex3) {}
/*     */       
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 133 */       ex.printStackTrace();
/*     */     }
/*     */     finally
/*     */     {
/*     */       try {
/* 138 */         SwingUtilities.invokeAndWait(new Runnable()
/*     */         {
/*     */           public void run() {
/* 141 */             UploadResourcesDialog.this.setVisible(false);
/* 142 */             UploadResourcesDialog.this.dispose();
/*     */           }
/*     */         });
/*     */       }
/*     */       catch (Exception ex3) {}
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */   public void setVisible(boolean b)
/*     */   {
/* 153 */     if (b) startProcessing();
/* 154 */     super.setVisible(b);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private void initComponents()
/*     */   {
/* 167 */     this.jLabel = new JLabel();
/* 168 */     this.jProgressBar1 = new JProgressBar();
/*     */     
/* 170 */     getContentPane().setLayout(new GridBagLayout());
/*     */     
/* 172 */     setDefaultCloseOperation(2);
/* 173 */     setResizable(false);
/* 174 */     this.jLabel.setText("Uploading resources...");
/* 175 */     GridBagConstraints gridBagConstraints = new GridBagConstraints();
/* 176 */     gridBagConstraints.fill = 2;
/* 177 */     gridBagConstraints.weightx = 1.0D;
/* 178 */     gridBagConstraints.insets = new Insets(8, 8, 4, 8);
/* 179 */     getContentPane().add(this.jLabel, gridBagConstraints);
/*     */     
/* 181 */     this.jProgressBar1.setPreferredSize(new Dimension(250, 18));
/* 182 */     gridBagConstraints = new GridBagConstraints();
/* 183 */     gridBagConstraints.gridx = 0;
/* 184 */     gridBagConstraints.fill = 2;
/* 185 */     gridBagConstraints.weightx = 1.0D;
/* 186 */     gridBagConstraints.insets = new Insets(0, 8, 8, 8);
/* 187 */     getContentPane().add(this.jProgressBar1, gridBagConstraints);
/*     */     
/* 189 */     pack();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public static void main(String[] args)
/*     */   {
/* 196 */     EventQueue.invokeLater(new Runnable() {
/*     */       public void run() {
/* 198 */         new UploadResourcesDialog(new JFrame(), true).setVisible(true);
/*     */       }
/*     */     });
/*     */   }
/*     */   
/*     */   public JrxmlValidationDialog getValidationDialog() {
/* 204 */     return this.validationDialog;
/*     */   }
/*     */   
/*     */   public void setValidationDialog(JrxmlValidationDialog validationDialog) {
/* 208 */     this.validationDialog = validationDialog;
/*     */   }
/*     */   
/*     */   public List getResourceItems() {
/* 212 */     return this.resourceItems;
/*     */   }
/*     */   
/*     */   public void setResourceItems(List resourceItems) {
/* 216 */     this.resourceItems = resourceItems;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jasperserver-ireport-plugin-2.0.1.jar!\com\jaspersoft\jasperserver\irplugin\gui\jrxmlvalidator\UploadResourcesDialog.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */