/*    */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.authority.roles;
/*    */ 
/*    */ import com.jaspersoft.jasperserver.dto.authority.ClientRole;
/*    */ import com.jaspersoft.jasperserver.dto.authority.RolesListWrapper;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.AbstractAdapter;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.Callback;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.JerseyRequest;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.RequestExecution;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.SessionStorage;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.ThreadPoolUtil;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.handling.DefaultErrorHandler;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.operationresult.OperationResult;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class SingleRoleRequestAdapter
/*    */   extends AbstractAdapter
/*    */ {
/*    */   private final String roleUriPrefix;
/*    */   
/*    */   public SingleRoleRequestAdapter(SessionStorage sessionStorage, String organizationId, String roleName)
/*    */   {
/* 36 */     super(sessionStorage);
/* 37 */     if (organizationId != null) {
/* 38 */       this.roleUriPrefix = ("/organizations/" + organizationId + "/roles/" + roleName);
/*    */     } else {
/* 40 */       this.roleUriPrefix = ("/roles/" + roleName);
/*    */     }
/*    */   }
/*    */   
/*    */   public OperationResult<ClientRole> get() {
/* 45 */     return buildRequest(ClientRole.class).get();
/*    */   }
/*    */   
/*    */   public <R> RequestExecution asyncGet(final Callback<OperationResult<ClientRole>, R> callback) {
/* 49 */     final JerseyRequest<ClientRole> request = buildRequest(ClientRole.class);
/* 50 */     RequestExecution task = new RequestExecution(new Runnable()
/*    */     {
/*    */       public void run() {
/* 53 */         callback.execute(request.get());
/*    */       }
/* 55 */     });
/* 56 */     ThreadPoolUtil.runAsynchronously(task);
/* 57 */     return task;
/*    */   }
/*    */   
/*    */   public OperationResult<RolesListWrapper> createOrUpdate(ClientRole user) {
/* 61 */     return buildRequest(RolesListWrapper.class).put(user);
/*    */   }
/*    */   
/*    */   public <R> RequestExecution asyncCreateOrUpdate(final ClientRole user, final Callback<OperationResult<RolesListWrapper>, R> callback) {
/* 65 */     final JerseyRequest<RolesListWrapper> request = buildRequest(RolesListWrapper.class);
/* 66 */     RequestExecution task = new RequestExecution(new Runnable()
/*    */     {
/*    */       public void run() {
/* 69 */         callback.execute(request.put(user));
/*    */       }
/* 71 */     });
/* 72 */     ThreadPoolUtil.runAsynchronously(task);
/* 73 */     return task;
/*    */   }
/*    */   
/*    */   public OperationResult delete() {
/* 77 */     return buildRequest(ClientRole.class).delete();
/*    */   }
/*    */   
/*    */   public <R> RequestExecution asyncDelete(final Callback<OperationResult<ClientRole>, R> callback) {
/* 81 */     final JerseyRequest<ClientRole> request = buildRequest(ClientRole.class);
/*    */     
/* 83 */     RequestExecution task = new RequestExecution(new Runnable()
/*    */     {
/*    */       public void run() {
/* 86 */         callback.execute(request.delete());
/*    */       }
/* 88 */     });
/* 89 */     ThreadPoolUtil.runAsynchronously(task);
/* 90 */     return task;
/*    */   }
/*    */   
/*    */   private <T> JerseyRequest<T> buildRequest(Class<T> returnType) {
/* 94 */     return JerseyRequest.buildRequest(this.sessionStorage, returnType, new String[] { this.roleUriPrefix }, new DefaultErrorHandler());
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\authority\roles\SingleRoleRequestAdapter.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */