/*     */ package com.netapp.asup.data.objects;
/*     */ 
/*     */ import java.util.Arrays;
/*     */ import org.apache.avro.Schema;
/*     */ import org.apache.avro.Schema.Field;
/*     */ import org.apache.avro.generic.GenericData.Array;
/*     */ import org.apache.avro.generic.GenericData.Record;
/*     */ import org.apache.avro.generic.GenericRecord;
/*     */ import org.apache.avro.util.Utf8;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class ObjectRequest
/*     */   extends AvroGenericRecordObject
/*     */ {
/*     */   private static final String IS_OBJECT_CACHED = "isObjectCached";
/*     */   private static final String ADD_BIZ_KEY_TO_TAGS = "addBizKeyToTags";
/*     */   private static final String INTERVAL = "interval";
/*     */   private static final String EVENT_NAMES = "eventNames";
/*     */   private static final String OBJECT_REQUEST = "objectRequest";
/*     */   private static final String NAME = "name";
/*     */   private static final String ALL = "ALL";
/*  27 */   private static final Utf8 UTF8_ALL = new Utf8("ALL");
/*     */   
/*     */   public static enum RequestObjectFields {
/*  30 */     FIELDS("fields"),  OPTIONS("options"),  PERFCOUNTERS("perfCounters"),  LOGEVENTS("logEvents"), 
/*  31 */     PERFCOUNTEROBJECTS("perfCounterObjects");
/*     */     
/*     */     private final String name;
/*     */     
/*     */     private RequestObjectFields(String name) {
/*  36 */       this.name = name;
/*     */     }
/*     */   }
/*     */   
/*     */   public ObjectRequest(ARMASchema schema, String id, String name) {
/*  41 */     super(schema, id);
/*  42 */     ((GenericRecord)this.object).put("isObjectCached", Boolean.valueOf(false));
/*  43 */     putStringValue("name", name);
/*     */     
/*  45 */     getNoOptions();
/*  46 */     getNoLogEvents();
/*  47 */     getNoFields();
/*     */   }
/*     */   
/*     */   public void getNoOptions()
/*     */   {
/*  52 */     setOptions(getEmptyArray(ARMASchema.OPTION_REQUEST.getSchema()));
/*     */   }
/*     */   
/*     */   public void getNoLogEvents()
/*     */   {
/*  57 */     setLogEvents(getEmptyLog());
/*     */   }
/*     */   
/*     */   private GenericRecord getEmptyLog()
/*     */   {
/*  62 */     GenericRecord logRequest = new GenericData.Record(ARMASchema.LOGEVENTS_REQUEST.getSchema());
/*  63 */     logRequest.put("interval", Integer.valueOf(0));
/*  64 */     GenericData.Array<Utf8> objectsArray = new GenericData.Array(0, logRequest.getSchema().getField("eventNames").schema());
/*     */     
/*     */ 
/*  67 */     logRequest.put("eventNames", objectsArray);
/*  68 */     logRequest.put("addBizKeyToTags", Boolean.valueOf(false));
/*  69 */     return logRequest;
/*     */   }
/*     */   
/*  72 */   public void getNoFields() { setFields(getEmptyArray(ARMASchema.FIELDS_REQUEST.getSchema())); }
/*     */   
/*     */   private GenericData.Array<Utf8> getEmptyArray(Schema schema)
/*     */   {
/*  76 */     GenericData.Array<Utf8> objectsArray = new GenericData.Array(0, schema);
/*  77 */     return objectsArray;
/*     */   }
/*     */   
/*     */   public void getALLOptions() {
/*  81 */     GenericData.Array<Utf8> objectsArray = new GenericData.Array(0, ARMASchema.OPTION_REQUEST.getSchema());
/*     */     
/*  83 */     objectsArray.add(UTF8_ALL);
/*  84 */     setOptions(objectsArray);
/*     */   }
/*     */   
/*     */   public ObjectRequest(GenericRecord object, String id) {
/*  88 */     super(ARMASchema.OBJECT_REQUEST, id);
/*  89 */     this.object = object;
/*     */   }
/*     */   
/*     */   public static ObjectRequest initialize(String id, String name) {
/*  93 */     return new ObjectRequest(ARMASchema.OBJECT_REQUEST, id, name);
/*     */   }
/*     */   
/*     */   public void setPerfCounters(GenericData.Array<Utf8> objects) {
/*  97 */     ((GenericRecord)this.object).put(RequestObjectFields.PERFCOUNTERS.name, objects);
/*     */   }
/*     */   
/*     */   public GenericData.Array<Utf8> getPerfCounters()
/*     */   {
/* 102 */     return (GenericData.Array)((GenericRecord)this.object).get(RequestObjectFields.PERFCOUNTERS.name);
/*     */   }
/*     */   
/*     */   public GenericData.Array<Utf8> getLogEvents()
/*     */   {
/* 107 */     return (GenericData.Array)((GenericRecord)this.object).get(RequestObjectFields.LOGEVENTS.name);
/*     */   }
/*     */   
/*     */   public void setObjectCached(Boolean isCached) {
/* 111 */     ((GenericRecord)this.object).put("isObjectCached", isCached);
/*     */   }
/*     */   
/*     */   public Boolean isObjectCached() {
/* 115 */     return (Boolean)((GenericRecord)this.object).get("isObjectCached");
/*     */   }
/*     */   
/*     */   public void setLogEvents(GenericRecord objects) {
/* 119 */     ((GenericRecord)this.object).put(RequestObjectFields.LOGEVENTS.name, objects);
/*     */   }
/*     */   
/*     */   public void setFields(GenericData.Array<Utf8> objects) {
/* 123 */     ((GenericRecord)this.object).put(RequestObjectFields.FIELDS.name, objects);
/*     */   }
/*     */   
/*     */   public GenericData.Array<Utf8> getObjects()
/*     */   {
/* 128 */     return (GenericData.Array)((GenericRecord)this.object).get(RequestObjectFields.FIELDS.name);
/*     */   }
/*     */   
/*     */   public GenericData.Array<Utf8> getOptions()
/*     */   {
/* 133 */     return (GenericData.Array)((GenericRecord)this.object).get(RequestObjectFields.OPTIONS.name);
/*     */   }
/*     */   
/*     */   public void setOptions(GenericData.Array<Utf8> objects) {
/* 137 */     ((GenericRecord)this.object).put(RequestObjectFields.OPTIONS.name, objects);
/*     */   }
/*     */   
/*     */   public boolean isOptionsAvailable() {
/* 141 */     return (getOptions() != null) && (getOptions().size() != 0);
/*     */   }
/*     */   
/*     */   public String getHash() {
/* 145 */     String hashString = getId() + getStringValue("name") + getOptions();
/* 146 */     String hash = String.valueOf(hashString.hashCode());
/* 147 */     return hash;
/*     */   }
/*     */   
/*     */ 
/*     */   public String getId()
/*     */   {
/* 153 */     return "objectRequest";
/*     */   }
/*     */   
/*     */   public void addPerfCounterData(int intervalInDays, String... counterObjectNames) {
/* 157 */     GenericRecord perfRequest = new GenericData.Record(ARMASchema.PERFCOUNTERS_REQUEST.getSchema());
/* 158 */     perfRequest.put("interval", Integer.valueOf(intervalInDays));
/* 159 */     perfRequest.put(RequestObjectFields.PERFCOUNTEROBJECTS.name, Arrays.asList(counterObjectNames));
/* 160 */     ((GenericRecord)this.object).put(RequestObjectFields.PERFCOUNTERS.name, perfRequest);
/*     */   }
/*     */   
/*     */   public void addLogEventData(int intervalInDays, boolean addBizKeyToTags, String... eventNames) {
/* 164 */     GenericRecord logRequest = new GenericData.Record(ARMASchema.LOGEVENTS_REQUEST.getSchema());
/*     */     
/* 166 */     logRequest.put("interval", Integer.valueOf(intervalInDays));
/* 167 */     GenericData.Array<Utf8> objectsArray = new GenericData.Array(eventNames.length, logRequest.getSchema().getField("eventNames").schema());
/*     */     
/*     */ 
/* 170 */     for (String eventName : eventNames) {
/* 171 */       objectsArray.add(new Utf8(eventName));
/*     */     }
/* 173 */     logRequest.put("eventNames", objectsArray);
/* 174 */     logRequest.put("addBizKeyToTags", Boolean.valueOf(addBizKeyToTags));
/* 175 */     setLogEvents(logRequest);
/*     */   }
/*     */   
/*     */   public GenericRecord getPerfCounterData() {
/* 179 */     return (GenericRecord)((GenericRecord)this.object).get(RequestObjectFields.PERFCOUNTERS.name);
/*     */   }
/*     */   
/*     */   public GenericRecord getLogEventData() {
/* 183 */     return (GenericRecord)((GenericRecord)this.object).get(RequestObjectFields.LOGEVENTS.name);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\objects\ObjectRequest.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */