/*    */ package com.netapp.asup.data.objects;
/*    */ 
/*    */ import com.netapp.asup.data.schema.SchemaHelper;
/*    */ import com.netapp.asup.data.store.BaseContainer;
/*    */ import com.netapp.asup.data.store.StoreContainer;
/*    */ import java.io.IOException;
/*    */ import java.util.HashMap;
/*    */ import java.util.HashSet;
/*    */ import java.util.Map;
/*    */ import java.util.Map.Entry;
/*    */ import java.util.Set;
/*    */ import org.apache.avro.generic.GenericRecord;
/*    */ import org.apache.avro.util.Utf8;
/*    */ 
/*    */ public class Objects
/*    */   extends AvroObject<Map<Utf8, GenericRecord>>
/*    */ {
/* 18 */   private static final SchemaHelper schemaHelper = BaseContainer.getInstance().getStoreContainer().getSchemaHelper();
/*    */   
/* 20 */   private final Map<Utf8, ObjectData> objectDataMap = new HashMap();
/*    */   
/*    */   public Objects(String id) {
/* 23 */     super(ARMASchema.OBJECTS, id);
/*    */   }
/*    */   
/*    */   public Set<Utf8> getObjectSet() {
/* 27 */     Set<Utf8> set = new HashSet();
/* 28 */     if (this.object != null) {
/* 29 */       set.addAll(((Map)this.object).keySet());
/*    */     }
/* 31 */     set.addAll(this.objectDataMap.keySet());
/* 32 */     return set;
/*    */   }
/*    */   
/*    */   public Objects(Map<Utf8, GenericRecord> object, String id) {
/* 36 */     super(ARMASchema.OBJECTS, id);
/* 37 */     this.object = object;
/*    */   }
/*    */   
/*    */   public ObjectData initializeObjectData(Utf8 objectName) {
/* 41 */     ObjectData objectData = (ObjectData)this.objectDataMap.get(objectName);
/* 42 */     if (objectData != null) {
/* 43 */       return objectData;
/*    */     }
/*    */     
/* 46 */     objectData = new ObjectData(objectName, schemaHelper.getLatestSchema(objectName.toString()), schemaHelper.getActiveSchema(objectName.toString()), this.id);
/* 47 */     this.objectDataMap.put(objectName, objectData);
/* 48 */     return objectData;
/*    */   }
/*    */   
/*    */ 
/*    */   public void putObjectData(ObjectData data)
/*    */   {
/* 54 */     this.objectDataMap.put(data.getName(), data);
/*    */   }
/*    */   
/*    */   public void removeObjectData(Utf8 objName) {
/* 58 */     this.objectDataMap.remove(objName);
/*    */   }
/*    */   
/*    */   public ObjectData getObjectData(Utf8 objectName) throws IOException {
/* 62 */     ObjectData objectData = (ObjectData)this.objectDataMap.get(objectName);
/* 63 */     if (objectData != null) {
/* 64 */       return objectData;
/*    */     }
/* 66 */     if ((this.object != null) && (((Map)this.object).get(objectName) != null)) {
/* 67 */       objectData = new ObjectData((GenericRecord)((Map)this.object).get(objectName), schemaHelper.getLatestSchema(objectName.toString()), schemaHelper.getActiveSchema(objectName.toString()), this.id);
/* 68 */       this.objectDataMap.put(objectName, objectData);
/* 69 */       return objectData;
/*    */     }
/* 71 */     return null;
/*    */   }
/*    */   
/*    */ 
/*    */   public Set<Utf8> getCurrentObjectNames()
/*    */   {
/* 77 */     Set<Utf8> keySet = this.objectDataMap.keySet();
/* 78 */     if (keySet.isEmpty()) {
/* 79 */       keySet = ((Map)this.object).keySet();
/*    */     }
/* 81 */     return keySet;
/*    */   }
/*    */   
/*    */   public Map<Utf8, GenericRecord> getObject() throws IOException
/*    */   {
/* 86 */     Map<Utf8, GenericRecord> object = new HashMap();
/* 87 */     for (Map.Entry<Utf8, ObjectData> entry : this.objectDataMap.entrySet()) {
/* 88 */       object.put(entry.getKey(), ((ObjectData)entry.getValue()).getObject());
/*    */     }
/* 90 */     return object;
/*    */   }
/*    */   
/*    */   public void merge(Object existingObject)
/*    */     throws IOException
/*    */   {
/* 96 */     Objects objects = (Objects)existingObject;
/* 97 */     Set<Utf8> objectSet = getObjectSet();
/* 98 */     for (Utf8 objectName : objectSet) {
/* 99 */       objects.putObjectData(getObjectData(objectName));
/*    */     }
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\objects\Objects.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */