/*     */ package com.sun.xml.bind.v2.runtime;
/*     */ 
/*     */ import com.sun.istack.SAXException2;
/*     */ import com.sun.xml.bind.marshaller.NamespacePrefixMapper;
/*     */ import com.sun.xml.bind.util.ValidationEventLocatorExImpl;
/*     */ import com.sun.xml.bind.v2.runtime.output.MTOMXmlOutput;
/*     */ import com.sun.xml.bind.v2.runtime.output.NamespaceContextImpl;
/*     */ import com.sun.xml.bind.v2.runtime.output.NamespaceContextImpl.Element;
/*     */ import com.sun.xml.bind.v2.runtime.output.Pcdata;
/*     */ import com.sun.xml.bind.v2.runtime.output.XmlOutput;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.Base64Data;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.IntData;
/*     */ import com.sun.xml.bind.v2.util.CollisionCheckStack;
/*     */ import java.io.IOException;
/*     */ import java.lang.reflect.Method;
/*     */ import java.util.HashSet;
/*     */ import java.util.Map;
/*     */ import java.util.Map.Entry;
/*     */ import java.util.Set;
/*     */ import javax.activation.MimeType;
/*     */ import javax.xml.bind.DatatypeConverter;
/*     */ import javax.xml.bind.JAXBException;
/*     */ import javax.xml.bind.Marshaller.Listener;
/*     */ import javax.xml.bind.ValidationEvent;
/*     */ import javax.xml.bind.ValidationEventHandler;
/*     */ import javax.xml.bind.ValidationEventLocator;
/*     */ import javax.xml.bind.annotation.DomHandler;
/*     */ import javax.xml.bind.attachment.AttachmentMarshaller;
/*     */ import javax.xml.bind.helpers.NotIdentifiableEventImpl;
/*     */ import javax.xml.bind.helpers.ValidationEventImpl;
/*     */ import javax.xml.bind.helpers.ValidationEventLocatorImpl;
/*     */ import javax.xml.namespace.QName;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import javax.xml.transform.Source;
/*     */ import javax.xml.transform.Transformer;
/*     */ import javax.xml.transform.TransformerException;
/*     */ import javax.xml.transform.sax.SAXResult;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class XMLSerializer
/*     */   extends Coordinator
/*     */ {
/*     */   public final JAXBContextImpl grammar;
/*     */   private XmlOutput out;
/*     */   public final NameList nameList;
/*     */   public final int[] knownUri2prefixIndexMap;
/*     */   private final NamespaceContextImpl nsContext;
/*     */   private NamespaceContextImpl.Element nse;
/* 132 */   private boolean textHasAlreadyPrinted = false;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/* 137 */   private boolean seenRoot = false;
/*     */   
/*     */ 
/*     */   private final MarshallerImpl marshaller;
/*     */   
/*     */ 
/* 143 */   private final Set<Object> idReferencedObjects = new HashSet();
/*     */   
/*     */ 
/* 146 */   private final Set<Object> objectsWithId = new HashSet();
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 152 */   private final CollisionCheckStack<Object> cycleDetectionStack = new CollisionCheckStack();
/*     */   
/*     */ 
/*     */ 
/*     */   private String schemaLocation;
/*     */   
/*     */ 
/*     */   private String noNsSchemaLocation;
/*     */   
/*     */ 
/*     */   private Transformer identityTransformer;
/*     */   
/*     */ 
/*     */   private ContentHandlerAdaptor contentHandlerAdapter;
/*     */   
/*     */ 
/*     */   private boolean fragment;
/*     */   
/*     */ 
/*     */   private Base64Data base64Data;
/*     */   
/*     */ 
/* 174 */   private final IntData intData = new IntData();
/*     */   public AttachmentMarshaller attachmentMarshaller;
/*     */   private MimeType expectedMimeType;
/*     */   private boolean inlineBinaryFlag;
/*     */   private QName schemaType;
/*     */   
/* 180 */   XMLSerializer(MarshallerImpl _owner) { this.marshaller = _owner;
/* 181 */     this.grammar = this.marshaller.context;
/* 182 */     this.nsContext = new NamespaceContextImpl(this);
/* 183 */     this.nameList = this.marshaller.context.nameList;
/* 184 */     this.knownUri2prefixIndexMap = new int[this.nameList.namespaceURIs.length];
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public Base64Data getCachedBase64DataInstance()
/*     */   {
/* 191 */     if (this.base64Data == null)
/* 192 */       this.base64Data = new Base64Data();
/* 193 */     return this.base64Data;
/*     */   }
/*     */   
/*     */ 
/*     */   private String getIdFromObject(Object identifiableObject)
/*     */     throws SAXException, JAXBException
/*     */   {
/* 200 */     return this.grammar.getBeanInfo(identifiableObject, true).getId(identifiableObject, this);
/*     */   }
/*     */   
/*     */   private void handleMissingObjectError(String fieldName) throws SAXException, IOException, XMLStreamException {
/* 204 */     reportMissingObjectError(fieldName);
/*     */     
/*     */ 
/* 207 */     endNamespaceDecls(null);
/* 208 */     endAttributes();
/*     */   }
/*     */   
/*     */   public void reportError(ValidationEvent ve) throws SAXException
/*     */   {
/*     */     ValidationEventHandler handler;
/*     */     try
/*     */     {
/* 216 */       handler = this.marshaller.getEventHandler();
/*     */     } catch (JAXBException e) {
/* 218 */       throw new SAXException2(e);
/*     */     }
/*     */     
/* 221 */     if (!handler.handleEvent(ve)) {
/* 222 */       if ((ve.getLinkedException() instanceof Exception)) {
/* 223 */         throw new SAXException2((Exception)ve.getLinkedException());
/*     */       }
/* 225 */       throw new SAXException2(ve.getMessage());
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final void reportError(String fieldName, Throwable t)
/*     */     throws SAXException
/*     */   {
/* 236 */     ValidationEvent ve = new ValidationEventImpl(1, t.getMessage(), getCurrentLocation(fieldName), t);
/*     */     
/* 238 */     reportError(ve);
/*     */   }
/*     */   
/*     */   public void startElement(Name tagName, Object outerPeer) {
/* 242 */     startElement();
/* 243 */     this.nse.setTagName(tagName, outerPeer);
/*     */   }
/*     */   
/*     */   public void startElement(String nsUri, String localName, String preferredPrefix, Object outerPeer) {
/* 247 */     startElement();
/* 248 */     int idx = this.nsContext.declareNsUri(nsUri, preferredPrefix, false);
/* 249 */     this.nse.setTagName(idx, localName, outerPeer);
/*     */   }
/*     */   
/*     */   public void endNamespaceDecls(Object innerPeer) throws IOException, XMLStreamException {
/* 253 */     this.nsContext.collectionMode = false;
/* 254 */     this.nse.startElement(this.out, innerPeer);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void endAttributes()
/*     */     throws SAXException, IOException, XMLStreamException
/*     */   {
/* 262 */     if (!this.seenRoot) {
/* 263 */       this.seenRoot = true;
/* 264 */       if ((this.schemaLocation != null) || (this.noNsSchemaLocation != null)) {
/* 265 */         int p = this.nsContext.getPrefixIndex("http://www.w3.org/2001/XMLSchema-instance");
/* 266 */         if (this.schemaLocation != null)
/* 267 */           this.out.attribute(p, "schemaLocation", this.schemaLocation);
/* 268 */         if (this.noNsSchemaLocation != null) {
/* 269 */           this.out.attribute(p, "noNamespaceSchemaLocation", this.noNsSchemaLocation);
/*     */         }
/*     */       }
/*     */     }
/* 273 */     this.out.endStartTag();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void endElement()
/*     */     throws SAXException, IOException, XMLStreamException
/*     */   {
/* 281 */     this.nse.endElement(this.out);
/* 282 */     this.nse = this.nse.pop();
/* 283 */     this.textHasAlreadyPrinted = false;
/*     */   }
/*     */   
/*     */   public void leafElement(Name tagName, String data, String fieldName) throws SAXException, IOException, XMLStreamException {
/* 287 */     if (this.seenRoot) {
/* 288 */       this.textHasAlreadyPrinted = false;
/* 289 */       this.nse = this.nse.push();
/* 290 */       this.out.beginStartTag(tagName);
/* 291 */       this.out.endStartTag();
/* 292 */       this.out.text(data, false);
/* 293 */       this.out.endTag(tagName);
/* 294 */       this.nse = this.nse.pop();
/*     */     }
/*     */     else
/*     */     {
/* 298 */       startElement(tagName, null);
/* 299 */       endNamespaceDecls(null);
/* 300 */       endAttributes();
/* 301 */       this.out.text(data, false);
/* 302 */       endElement();
/*     */     }
/*     */   }
/*     */   
/*     */   public void leafElement(Name tagName, Pcdata data, String fieldName) throws SAXException, IOException, XMLStreamException {
/* 307 */     if (this.seenRoot) {
/* 308 */       this.textHasAlreadyPrinted = false;
/* 309 */       this.nse = this.nse.push();
/* 310 */       this.out.beginStartTag(tagName);
/* 311 */       this.out.endStartTag();
/* 312 */       this.out.text(data, false);
/* 313 */       this.out.endTag(tagName);
/* 314 */       this.nse = this.nse.pop();
/*     */     }
/*     */     else
/*     */     {
/* 318 */       startElement(tagName, null);
/* 319 */       endNamespaceDecls(null);
/* 320 */       endAttributes();
/* 321 */       this.out.text(data, false);
/* 322 */       endElement();
/*     */     }
/*     */   }
/*     */   
/*     */   public void leafElement(Name tagName, int data, String fieldName) throws SAXException, IOException, XMLStreamException {
/* 327 */     this.intData.reset(data);
/* 328 */     leafElement(tagName, this.intData, fieldName);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void text(String text, String fieldName)
/*     */     throws SAXException, IOException, XMLStreamException
/*     */   {
/* 368 */     if (text == null) {
/* 369 */       reportMissingObjectError(fieldName);
/* 370 */       return;
/*     */     }
/*     */     
/* 373 */     this.out.text(text, this.textHasAlreadyPrinted);
/* 374 */     this.textHasAlreadyPrinted = true;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public void text(Pcdata text, String fieldName)
/*     */     throws SAXException, IOException, XMLStreamException
/*     */   {
/* 383 */     if (text == null) {
/* 384 */       reportMissingObjectError(fieldName);
/* 385 */       return;
/*     */     }
/*     */     
/* 388 */     this.out.text(text, this.textHasAlreadyPrinted);
/* 389 */     this.textHasAlreadyPrinted = true;
/*     */   }
/*     */   
/*     */   public void attribute(String uri, String local, String value) throws SAXException { int prefix;
/*     */     int prefix;
/* 394 */     if (uri.length() == 0)
/*     */     {
/* 396 */       prefix = -1;
/*     */     } else {
/* 398 */       prefix = this.nsContext.getPrefixIndex(uri);
/*     */     }
/*     */     try
/*     */     {
/* 402 */       this.out.attribute(prefix, local, value);
/*     */     } catch (IOException e) {
/* 404 */       throw new SAXException2(e);
/*     */     } catch (XMLStreamException e) {
/* 406 */       throw new SAXException2(e);
/*     */     }
/*     */   }
/*     */   
/*     */   public void attribute(Name name, CharSequence value)
/*     */     throws IOException, XMLStreamException
/*     */   {
/* 413 */     this.out.attribute(name, value.toString());
/*     */   }
/*     */   
/*     */   public NamespaceContext2 getNamespaceContext() {
/* 417 */     return this.nsContext;
/*     */   }
/*     */   
/*     */   public String onID(Object owner, String value)
/*     */   {
/* 422 */     this.objectsWithId.add(owner);
/* 423 */     return value;
/*     */   }
/*     */   
/*     */   public String onIDREF(Object obj) throws SAXException {
/*     */     String id;
/*     */     try {
/* 429 */       id = getIdFromObject(obj);
/*     */     } catch (JAXBException e) {
/* 431 */       reportError(null, e);
/* 432 */       return null;
/*     */     }
/* 434 */     this.idReferencedObjects.add(obj);
/* 435 */     if (id == null) {
/* 436 */       reportError(new NotIdentifiableEventImpl(1, Messages.NOT_IDENTIFIABLE.format(new Object[0]), new ValidationEventLocatorImpl(obj)));
/*     */     }
/*     */     
/*     */ 
/*     */ 
/* 441 */     return id;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void childAsRoot(Object obj)
/*     */     throws JAXBException, IOException, SAXException, XMLStreamException
/*     */   {
/* 449 */     JaxBeanInfo beanInfo = this.grammar.getBeanInfo(obj, true);
/*     */     
/*     */ 
/*     */ 
/*     */ 
/* 454 */     this.cycleDetectionStack.pushNocheck(obj);
/*     */     
/* 456 */     boolean lookForLifecycleMethods = beanInfo.lookForLifecycleMethods();
/* 457 */     if (lookForLifecycleMethods) {
/* 458 */       fireBeforeMarshalEvents(beanInfo, obj);
/*     */     }
/*     */     
/* 461 */     beanInfo.serializeRoot(obj, this);
/*     */     
/* 463 */     if (lookForLifecycleMethods) {
/* 464 */       fireAfterMarshalEvents(beanInfo, obj);
/*     */     }
/*     */     
/* 467 */     this.cycleDetectionStack.pop();
/*     */   }
/*     */   
/*     */   private void pushObject(Object obj, String fieldName) throws SAXException {
/* 471 */     if (this.cycleDetectionStack.push(obj))
/*     */     {
/* 473 */       StringBuilder sb = new StringBuilder();
/* 474 */       sb.append(obj);
/* 475 */       int i = this.cycleDetectionStack.size() - 1;
/*     */       Object x;
/*     */       do {
/* 478 */         sb.append(" -> ");
/* 479 */         x = this.cycleDetectionStack.get(--i);
/* 480 */         sb.append(x);
/* 481 */       } while (obj != x);
/*     */       
/* 483 */       reportError(new ValidationEventImpl(1, Messages.CYCLE_IN_MARSHALLER.format(new Object[] { sb }), getCurrentLocation(fieldName), null));
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final void childAsSoleContent(Object child, String fieldName)
/*     */     throws SAXException, IOException, XMLStreamException
/*     */   {
/* 507 */     if (child == null) {
/* 508 */       handleMissingObjectError(fieldName);
/*     */     } else {
/*     */       JaxBeanInfo beanInfo;
/*     */       try {
/* 512 */         beanInfo = this.grammar.getBeanInfo(child, true);
/*     */       } catch (JAXBException e) {
/* 514 */         reportError(fieldName, e);
/*     */         
/* 516 */         endNamespaceDecls(null);
/* 517 */         endAttributes();
/* 518 */         return;
/*     */       }
/*     */       
/* 521 */       pushObject(child, fieldName);
/*     */       
/* 523 */       boolean lookForLifecycleMethods = beanInfo.lookForLifecycleMethods();
/* 524 */       if (lookForLifecycleMethods) {
/* 525 */         fireBeforeMarshalEvents(beanInfo, child);
/*     */       }
/*     */       
/* 528 */       beanInfo.serializeURIs(child, this);
/* 529 */       endNamespaceDecls(child);
/* 530 */       beanInfo.serializeAttributes(child, this);
/* 531 */       endAttributes();
/* 532 */       beanInfo.serializeBody(child, this);
/*     */       
/* 534 */       if (lookForLifecycleMethods) {
/* 535 */         fireAfterMarshalEvents(beanInfo, child);
/*     */       }
/*     */       
/* 538 */       this.cycleDetectionStack.pop();
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final void childAsXsiType(Object child, String fieldName, JaxBeanInfo expected)
/*     */     throws SAXException, IOException, XMLStreamException
/*     */   {
/* 567 */     if (child == null) {
/* 568 */       handleMissingObjectError(fieldName);
/*     */     } else {
/* 570 */       boolean asExpected = child.getClass() == expected.jaxbType;
/* 571 */       JaxBeanInfo actual = expected;
/* 572 */       QName actualTypeName = null;
/*     */       
/* 574 */       pushObject(child, fieldName);
/*     */       
/* 576 */       if ((asExpected) && (actual.lookForLifecycleMethods())) {
/* 577 */         fireBeforeMarshalEvents(actual, child);
/*     */       }
/*     */       
/* 580 */       if (!asExpected) {
/*     */         try {
/* 582 */           actual = this.grammar.getBeanInfo(child, true);
/* 583 */           if (actual.lookForLifecycleMethods()) {
/* 584 */             fireBeforeMarshalEvents(actual, child);
/*     */           }
/*     */         } catch (JAXBException e) {
/* 587 */           reportError(fieldName, e);
/* 588 */           endNamespaceDecls(null);
/* 589 */           endAttributes();
/* 590 */           return;
/*     */         }
/* 592 */         if (actual == expected) {
/* 593 */           asExpected = true;
/*     */         } else {
/* 595 */           actualTypeName = actual.getTypeName(child);
/* 596 */           if (actualTypeName == null) {
/* 597 */             reportError(new ValidationEventImpl(1, Messages.SUBSTITUTED_BY_ANONYMOUS_TYPE.format(new Object[] { expected.jaxbType.getName(), child.getClass().getName(), actual.jaxbType.getName() }), getCurrentLocation(fieldName)));
/*     */ 
/*     */ 
/*     */ 
/*     */           }
/*     */           else
/*     */           {
/*     */ 
/*     */ 
/* 606 */             getNamespaceContext().declareNamespace("http://www.w3.org/2001/XMLSchema-instance", "xsi", true);
/* 607 */             getNamespaceContext().declareNamespace(actualTypeName.getNamespaceURI(), null, false);
/*     */           }
/*     */         }
/*     */       }
/* 611 */       actual.serializeURIs(child, this);
/* 612 */       endNamespaceDecls(child);
/* 613 */       if (!asExpected) {
/* 614 */         attribute("http://www.w3.org/2001/XMLSchema-instance", "type", DatatypeConverter.printQName(actualTypeName, getNamespaceContext()));
/*     */       }
/*     */       
/* 617 */       actual.serializeAttributes(child, this);
/* 618 */       endAttributes();
/* 619 */       actual.serializeBody(child, this);
/*     */       
/* 621 */       if (actual.lookForLifecycleMethods()) {
/* 622 */         fireAfterMarshalEvents(actual, child);
/*     */       }
/*     */       
/* 625 */       this.cycleDetectionStack.pop();
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private void fireAfterMarshalEvents(JaxBeanInfo beanInfo, Object currentTarget)
/*     */   {
/* 640 */     if (beanInfo.hasAfterMarshalMethod()) {
/* 641 */       Method m = beanInfo.getLifecycleMethods().getAfterMarshal();
/* 642 */       fireMarshalEvent(currentTarget, m);
/*     */     }
/*     */     
/*     */ 
/* 646 */     Marshaller.Listener externalListener = this.marshaller.getListener();
/* 647 */     if (externalListener != null) {
/* 648 */       externalListener.afterMarshal(currentTarget);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private void fireBeforeMarshalEvents(JaxBeanInfo beanInfo, Object currentTarget)
/*     */   {
/* 664 */     if (beanInfo.hasBeforeMarshalMethod()) {
/* 665 */       Method m = beanInfo.getLifecycleMethods().getBeforeMarshal();
/* 666 */       fireMarshalEvent(currentTarget, m);
/*     */     }
/*     */     
/*     */ 
/* 670 */     Marshaller.Listener externalListener = this.marshaller.getListener();
/* 671 */     if (externalListener != null) {
/* 672 */       externalListener.beforeMarshal(currentTarget);
/*     */     }
/*     */   }
/*     */   
/*     */   private void fireMarshalEvent(Object target, Method m) {
/*     */     try {
/* 678 */       m.invoke(target, new Object[] { this.marshaller });
/*     */     }
/*     */     catch (Exception e) {
/* 681 */       throw new IllegalStateException(e);
/*     */     }
/*     */   }
/*     */   
/*     */   public void attWildcardAsURIs(Map<QName, String> attributes, String fieldName) {
/* 686 */     if (attributes == null) return;
/* 687 */     for (Map.Entry<QName, String> e : attributes.entrySet()) {
/* 688 */       QName n = (QName)e.getKey();
/* 689 */       String nsUri = n.getNamespaceURI();
/* 690 */       if (nsUri.length() > 0) {
/* 691 */         String p = n.getPrefix();
/* 692 */         if (p.length() == 0) p = null;
/* 693 */         this.nsContext.declareNsUri(nsUri, p, true);
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   public void attWildcardAsAttributes(Map<QName, String> attributes, String fieldName) throws SAXException {
/* 699 */     if (attributes == null) return;
/* 700 */     for (Map.Entry<QName, String> e : attributes.entrySet()) {
/* 701 */       QName n = (QName)e.getKey();
/* 702 */       attribute(n.getNamespaceURI(), n.getLocalPart(), (String)e.getValue());
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final void writeXsiNilTrue()
/*     */     throws SAXException, IOException, XMLStreamException
/*     */   {
/* 717 */     getNamespaceContext().declareNamespace("http://www.w3.org/2001/XMLSchema-instance", "xsi", true);
/* 718 */     endNamespaceDecls(null);
/* 719 */     attribute("http://www.w3.org/2001/XMLSchema-instance", "nil", "true");
/* 720 */     endAttributes();
/*     */   }
/*     */   
/*     */   public <E> void writeDom(E element, DomHandler<E, ?> domHandler, Object parentBean, String fieldName) throws SAXException {
/* 724 */     Source source = domHandler.marshal(element, this);
/* 725 */     if (this.contentHandlerAdapter == null)
/* 726 */       this.contentHandlerAdapter = new ContentHandlerAdaptor(this);
/*     */     try {
/* 728 */       getIdentityTransformer().transform(source, new SAXResult(this.contentHandlerAdapter));
/*     */     } catch (TransformerException e) {
/* 730 */       reportError(fieldName, e);
/*     */     }
/*     */   }
/*     */   
/*     */   public Transformer getIdentityTransformer() {
/* 735 */     if (this.identityTransformer == null)
/* 736 */       this.identityTransformer = JAXBContextImpl.createTransformer();
/* 737 */     return this.identityTransformer;
/*     */   }
/*     */   
/*     */   public void setPrefixMapper(NamespacePrefixMapper prefixMapper) {
/* 741 */     this.nsContext.setPrefixMapper(prefixMapper);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void startDocument(XmlOutput out, boolean fragment, String schemaLocation, String noNsSchemaLocation)
/*     */     throws IOException, SAXException, XMLStreamException
/*     */   {
/* 753 */     setThreadAffinity();
/* 754 */     pushCoordinator();
/* 755 */     this.nsContext.reset();
/* 756 */     this.nse = this.nsContext.getCurrent();
/* 757 */     if ((this.attachmentMarshaller != null) && (this.attachmentMarshaller.isXOPPackage()))
/* 758 */       out = new MTOMXmlOutput(out);
/* 759 */     this.out = out;
/* 760 */     this.objectsWithId.clear();
/* 761 */     this.idReferencedObjects.clear();
/* 762 */     this.textHasAlreadyPrinted = false;
/* 763 */     this.seenRoot = false;
/* 764 */     this.schemaLocation = schemaLocation;
/* 765 */     this.noNsSchemaLocation = noNsSchemaLocation;
/* 766 */     this.fragment = fragment;
/* 767 */     this.inlineBinaryFlag = false;
/* 768 */     this.expectedMimeType = null;
/* 769 */     this.cycleDetectionStack.reset();
/*     */     
/* 771 */     out.startDocument(this, fragment, this.knownUri2prefixIndexMap, this.nsContext);
/*     */   }
/*     */   
/*     */   public void endDocument() throws IOException, SAXException, XMLStreamException {
/* 775 */     this.out.endDocument(this.fragment);
/*     */   }
/*     */   
/*     */   public void close() {
/* 779 */     popCoordinator();
/* 780 */     resetThreadAffinity();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void addInscopeBinding(String nsUri, String prefix)
/*     */   {
/* 793 */     this.nsContext.put(nsUri, prefix);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getXMIMEContentType()
/*     */   {
/* 807 */     String v = this.grammar.getXMIMEContentType(this.cycleDetectionStack.peek());
/* 808 */     if (v != null) { return v;
/*     */     }
/*     */     
/* 811 */     if (this.expectedMimeType != null) {
/* 812 */       return this.expectedMimeType.toString();
/*     */     }
/* 814 */     return null;
/*     */   }
/*     */   
/*     */   private void startElement() {
/* 818 */     this.nse = this.nse.push();
/*     */     
/* 820 */     if (!this.seenRoot)
/*     */     {
/*     */ 
/* 823 */       String[] knownUris = this.nameList.namespaceURIs;
/* 824 */       for (int i = 0; i < knownUris.length; i++) {
/* 825 */         this.knownUri2prefixIndexMap[i] = this.nsContext.declareNsUri(knownUris[i], null, this.nameList.nsUriCannotBeDefaulted[i]);
/*     */       }
/*     */       
/*     */ 
/* 829 */       String[] uris = this.nsContext.getPrefixMapper().getPreDeclaredNamespaceUris();
/* 830 */       if (uris != null) {
/* 831 */         for (String uri : uris) {
/* 832 */           if (uri != null)
/* 833 */             this.nsContext.declareNsUri(uri, null, false);
/*     */         }
/*     */       }
/* 836 */       String[] pairs = this.nsContext.getPrefixMapper().getPreDeclaredNamespaceUris2();
/* 837 */       if (pairs != null) {
/* 838 */         for (int i = 0; i < pairs.length; i += 2) {
/* 839 */           String prefix = pairs[i];
/* 840 */           String nsUri = pairs[(i + 1)];
/* 841 */           if ((prefix != null) && (nsUri != null))
/*     */           {
/*     */ 
/*     */ 
/* 845 */             this.nsContext.put(nsUri, prefix);
/*     */           }
/*     */         }
/*     */       }
/* 849 */       if ((this.schemaLocation != null) || (this.noNsSchemaLocation != null)) {
/* 850 */         this.nsContext.declareNsUri("http://www.w3.org/2001/XMLSchema-instance", "xsi", true);
/*     */       }
/*     */     }
/*     */     
/* 854 */     this.nsContext.collectionMode = true;
/* 855 */     this.textHasAlreadyPrinted = false;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public MimeType setExpectedMimeType(MimeType expectedMimeType)
/*     */   {
/* 865 */     MimeType old = this.expectedMimeType;
/* 866 */     this.expectedMimeType = expectedMimeType;
/* 867 */     return old;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean setInlineBinaryFlag(boolean value)
/*     */   {
/* 876 */     boolean old = this.inlineBinaryFlag;
/* 877 */     this.inlineBinaryFlag = value;
/* 878 */     return old;
/*     */   }
/*     */   
/*     */   public boolean getInlineBinaryFlag() {
/* 882 */     return this.inlineBinaryFlag;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public QName setSchemaType(QName st)
/*     */   {
/* 897 */     QName old = this.schemaType;
/* 898 */     this.schemaType = st;
/* 899 */     return old;
/*     */   }
/*     */   
/*     */   public QName getSchemaType() {
/* 903 */     return this.schemaType;
/*     */   }
/*     */   
/*     */   void reconcileID() throws SAXException
/*     */   {
/* 908 */     this.idReferencedObjects.removeAll(this.objectsWithId);
/*     */     
/* 910 */     for (Object idObj : this.idReferencedObjects) {
/*     */       try {
/* 912 */         String id = getIdFromObject(idObj);
/* 913 */         reportError(new NotIdentifiableEventImpl(1, Messages.DANGLING_IDREF.format(new Object[] { id }), new ValidationEventLocatorImpl(idObj)));
/*     */       }
/*     */       catch (JAXBException e) {}
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 923 */     this.idReferencedObjects.clear();
/* 924 */     this.objectsWithId.clear();
/*     */   }
/*     */   
/*     */   public boolean handleError(Exception e) {
/* 928 */     return handleError(e, this.cycleDetectionStack.peek(), null);
/*     */   }
/*     */   
/*     */   public boolean handleError(Exception e, Object source, String fieldName) {
/* 932 */     return handleEvent(new ValidationEventImpl(1, e.getMessage(), new ValidationEventLocatorExImpl(source, fieldName), e));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean handleEvent(ValidationEvent event)
/*     */   {
/*     */     try
/*     */     {
/* 942 */       return this.marshaller.getEventHandler().handleEvent(event);
/*     */     }
/*     */     catch (JAXBException e) {
/* 945 */       throw new Error(e);
/*     */     }
/*     */   }
/*     */   
/*     */   private void reportMissingObjectError(String fieldName) throws SAXException {
/* 950 */     reportError(new ValidationEventImpl(1, Messages.MISSING_OBJECT.format(new Object[] { fieldName }), getCurrentLocation(fieldName), new NullPointerException()));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void errorMissingId(Object obj)
/*     */     throws SAXException
/*     */   {
/* 961 */     reportError(new ValidationEventImpl(1, Messages.MISSING_ID.format(new Object[] { obj }), new ValidationEventLocatorImpl(obj)));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public ValidationEventLocator getCurrentLocation(String fieldName)
/*     */   {
/* 968 */     return new ValidationEventLocatorExImpl(this.cycleDetectionStack.peek(), fieldName);
/*     */   }
/*     */   
/*     */   protected ValidationEventLocator getLocation() {
/* 972 */     return getCurrentLocation(null);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public static XMLSerializer getInstance()
/*     */   {
/* 980 */     return (XMLSerializer)Coordinator._getInstance();
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\XMLSerializer.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */