/*     */ package com.sun.xml.bind.v2.runtime.property;
/*     */ 
/*     */ import com.sun.xml.bind.api.AccessorException;
/*     */ import com.sun.xml.bind.v2.model.core.PropertyKind;
/*     */ import com.sun.xml.bind.v2.model.core.TypeRef;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeElementPropertyInfo;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeTypeInfo;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeTypeRef;
/*     */ import com.sun.xml.bind.v2.runtime.JAXBContextImpl;
/*     */ import com.sun.xml.bind.v2.runtime.JaxBeanInfo;
/*     */ import com.sun.xml.bind.v2.runtime.Name;
/*     */ import com.sun.xml.bind.v2.runtime.NameBuilder;
/*     */ import com.sun.xml.bind.v2.runtime.XMLSerializer;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.Accessor;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.ChildLoader;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.DefaultValueLoaderDecorator;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.Loader;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.XsiNilLoader.Single;
/*     */ import com.sun.xml.bind.v2.util.QNameMap;
/*     */ import java.io.IOException;
/*     */ import java.lang.reflect.Type;
/*     */ import java.util.Collection;
/*     */ import java.util.HashMap;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import java.util.Map.Entry;
/*     */ import javax.xml.namespace.QName;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ final class SingleElementNodeProperty<BeanT, ValueT>
/*     */   extends PropertyImpl<BeanT>
/*     */ {
/*     */   private final Accessor<BeanT, ValueT> acc;
/*     */   private final boolean nillable;
/*     */   private final QName[] acceptedElements;
/*  42 */   private final Map<Class, TagAndType> typeNames = new HashMap();
/*     */   
/*     */ 
/*     */   private RuntimeElementPropertyInfo prop;
/*     */   
/*     */   private final Name nullTagName;
/*     */   
/*     */ 
/*     */   public SingleElementNodeProperty(JAXBContextImpl context, RuntimeElementPropertyInfo prop)
/*     */   {
/*  52 */     super(context, prop);
/*  53 */     this.acc = prop.getAccessor().optimize();
/*  54 */     this.prop = prop;
/*     */     
/*  56 */     QName nt = null;
/*  57 */     boolean nil = false;
/*     */     
/*  59 */     this.acceptedElements = new QName[prop.getTypes().size()];
/*  60 */     for (int i = 0; i < this.acceptedElements.length; i++) {
/*  61 */       this.acceptedElements[i] = ((RuntimeTypeRef)prop.getTypes().get(i)).getTagName();
/*     */     }
/*  63 */     for (RuntimeTypeRef e : prop.getTypes()) {
/*  64 */       JaxBeanInfo beanInfo = context.getOrCreate(e.getTarget());
/*  65 */       if (nt == null) nt = e.getTagName();
/*  66 */       this.typeNames.put(beanInfo.jaxbType, new TagAndType(context.nameBuilder.createElementName(e.getTagName()), beanInfo));
/*     */       
/*  68 */       nil |= e.isNillable();
/*     */     }
/*     */     
/*  71 */     this.nullTagName = context.nameBuilder.createElementName(nt);
/*     */     
/*  73 */     this.nillable = nil;
/*     */   }
/*     */   
/*     */   public void wrapUp() {
/*  77 */     super.wrapUp();
/*  78 */     this.prop = null;
/*     */   }
/*     */   
/*     */   public void reset(BeanT bean) throws AccessorException {
/*  82 */     this.acc.set(bean, null);
/*     */   }
/*     */   
/*     */   public String getIdValue(BeanT beanT) {
/*  86 */     return null;
/*     */   }
/*     */   
/*     */   public void serializeBody(BeanT o, XMLSerializer w, Object outerPeer) throws SAXException, AccessorException, IOException, XMLStreamException {
/*  90 */     ValueT v = this.acc.get(o);
/*  91 */     if (v != null) {
/*  92 */       Class vtype = v.getClass();
/*  93 */       TagAndType tt = (TagAndType)this.typeNames.get(vtype);
/*     */       
/*  95 */       if (tt == null) {
/*  96 */         for (Map.Entry<Class, TagAndType> e : this.typeNames.entrySet()) {
/*  97 */           if (((Class)e.getKey()).isAssignableFrom(vtype)) {
/*  98 */             tt = (TagAndType)e.getValue();
/*  99 */             break;
/*     */           }
/*     */         }
/*     */       }
/*     */       
/* 104 */       if (tt == null)
/*     */       {
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 110 */         w.startElement(((TagAndType)this.typeNames.values().iterator().next()).tagName, null);
/* 111 */         w.childAsXsiType(v, this.fieldName, w.grammar.getBeanInfo(Object.class));
/*     */       } else {
/* 113 */         w.startElement(tt.tagName, null);
/* 114 */         w.childAsXsiType(v, this.fieldName, tt.beanInfo);
/*     */       }
/* 116 */       w.endElement();
/*     */     }
/* 118 */     else if (this.nillable) {
/* 119 */       w.startElement(this.nullTagName, null);
/* 120 */       w.writeXsiNilTrue();
/* 121 */       w.endElement();
/*     */     }
/*     */   }
/*     */   
/*     */   public void buildChildElementUnmarshallers(UnmarshallerChain chain, QNameMap<ChildLoader> handlers) {
/* 126 */     JAXBContextImpl context = chain.context;
/*     */     
/* 128 */     for (TypeRef<Type, Class> e : this.prop.getTypes()) {
/* 129 */       JaxBeanInfo bi = context.getOrCreate((RuntimeTypeInfo)e.getTarget());
/* 130 */       Loader l = bi.getLoader(context, true);
/* 131 */       if (e.getDefaultValue() != null)
/* 132 */         l = new DefaultValueLoaderDecorator(l, e.getDefaultValue());
/* 133 */       if (this.nillable)
/* 134 */         l = new XsiNilLoader.Single(l, this.acc);
/* 135 */       handlers.put(e.getTagName(), new ChildLoader(l, this.acc));
/*     */     }
/*     */   }
/*     */   
/*     */   public PropertyKind getKind() {
/* 140 */     return PropertyKind.ELEMENT;
/*     */   }
/*     */   
/*     */   public Accessor getElementPropertyAccessor(String nsUri, String localName)
/*     */   {
/* 145 */     for (QName n : this.acceptedElements) {
/* 146 */       if ((n.getNamespaceURI().equals(nsUri)) && (n.getLocalPart().equals(localName)))
/* 147 */         return this.acc;
/*     */     }
/* 149 */     return null;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\property\SingleElementNodeProperty.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */