/*     */ package com.sun.xml.bind.v2.runtime.property;
/*     */ 
/*     */ import com.sun.xml.bind.api.AccessorException;
/*     */ import com.sun.xml.bind.v2.ClassFactory;
/*     */ import com.sun.xml.bind.v2.model.core.PropertyKind;
/*     */ import com.sun.xml.bind.v2.model.core.WildcardMode;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeElement;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeReferencePropertyInfo;
/*     */ import com.sun.xml.bind.v2.runtime.ElementBeanInfoImpl;
/*     */ import com.sun.xml.bind.v2.runtime.JAXBContextImpl;
/*     */ import com.sun.xml.bind.v2.runtime.JaxBeanInfo;
/*     */ import com.sun.xml.bind.v2.runtime.XMLSerializer;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.Accessor;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.ChildLoader;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.WildcardLoader;
/*     */ import com.sun.xml.bind.v2.util.QNameMap;
/*     */ import com.sun.xml.bind.v2.util.QNameMap.Entry;
/*     */ import java.io.IOException;
/*     */ import javax.xml.bind.JAXBElement;
/*     */ import javax.xml.bind.JAXBException;
/*     */ import javax.xml.bind.annotation.DomHandler;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ final class SingleReferenceNodeProperty<BeanT, ValueT>
/*     */   extends PropertyImpl<BeanT>
/*     */ {
/*     */   private final Accessor<BeanT, ValueT> acc;
/*  34 */   private final QNameMap<JaxBeanInfo> expectedElements = new QNameMap();
/*     */   private final DomHandler domHandler;
/*     */   private final WildcardMode wcMode;
/*     */   
/*     */   public SingleReferenceNodeProperty(JAXBContextImpl p, RuntimeReferencePropertyInfo prop)
/*     */   {
/*  40 */     super(p, prop);
/*  41 */     this.acc = prop.getAccessor().optimize();
/*     */     
/*  43 */     for (RuntimeElement e : prop.getElements()) {
/*  44 */       this.expectedElements.put(e.getElementName(), p.getOrCreate(e));
/*     */     }
/*     */     
/*  47 */     if (prop.getWildcard() != null) {
/*  48 */       this.domHandler = ((DomHandler)ClassFactory.create((Class)prop.getDOMHandler()));
/*  49 */       this.wcMode = prop.getWildcard();
/*     */     } else {
/*  51 */       this.domHandler = null;
/*  52 */       this.wcMode = null;
/*     */     }
/*     */   }
/*     */   
/*     */   public void reset(BeanT bean) throws AccessorException {
/*  57 */     this.acc.set(bean, null);
/*     */   }
/*     */   
/*     */   public String getIdValue(BeanT beanT) {
/*  61 */     return null;
/*     */   }
/*     */   
/*     */   public void serializeBody(BeanT o, XMLSerializer w, Object outerPeer) throws SAXException, AccessorException, IOException, XMLStreamException {
/*  65 */     ValueT v = this.acc.get(o);
/*  66 */     if (v != null) {
/*     */       try {
/*  68 */         JaxBeanInfo bi = w.grammar.getBeanInfo(v, true);
/*  69 */         if ((bi.jaxbType == Object.class) && (this.domHandler != null))
/*     */         {
/*     */ 
/*  72 */           w.writeDom(v, this.domHandler, o, this.fieldName);
/*     */         } else
/*  74 */           bi.serializeRoot(v, w);
/*     */       } catch (JAXBException e) {
/*  76 */         w.reportError(this.fieldName, e);
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   public void buildChildElementUnmarshallers(UnmarshallerChain chain, QNameMap<ChildLoader> handlers)
/*     */   {
/*  83 */     for (QNameMap.Entry<JaxBeanInfo> n : this.expectedElements.entrySet()) {
/*  84 */       handlers.put(n.nsUri, n.localName, new ChildLoader(((JaxBeanInfo)n.getValue()).getLoader(chain.context, true), this.acc));
/*     */     }
/*  86 */     if (this.domHandler != null) {
/*  87 */       handlers.put(CATCH_ALL, new ChildLoader(new WildcardLoader(this.domHandler, this.wcMode), this.acc));
/*     */     }
/*     */   }
/*     */   
/*     */   public PropertyKind getKind() {
/*  92 */     return PropertyKind.REFERENCE;
/*     */   }
/*     */   
/*     */   public Accessor getElementPropertyAccessor(String nsUri, String localName)
/*     */   {
/*  97 */     JaxBeanInfo bi = (JaxBeanInfo)this.expectedElements.get(nsUri, localName);
/*  98 */     if (bi != null) {
/*  99 */       if ((bi instanceof ElementBeanInfoImpl)) {
/* 100 */         final ElementBeanInfoImpl ebi = (ElementBeanInfoImpl)bi;
/*     */         
/* 102 */         new Accessor(ebi.expectedType) {
/*     */           public Object get(BeanT bean) throws AccessorException {
/* 104 */             ValueT r = SingleReferenceNodeProperty.this.acc.get(bean);
/* 105 */             if ((r instanceof JAXBElement)) {
/* 106 */               return ((JAXBElement)r).getValue();
/*     */             }
/*     */             
/* 109 */             return r;
/*     */           }
/*     */           
/*     */           public void set(BeanT bean, Object value) throws AccessorException {
/* 113 */             if (value != null) {
/* 114 */               value = ebi.createInstanceFromValue(value);
/*     */             }
/* 116 */             SingleReferenceNodeProperty.this.acc.set(bean, value);
/*     */           }
/*     */         };
/*     */       }
/*     */       
/* 121 */       return this.acc;
/*     */     }
/*     */     
/* 124 */     return null;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\property\SingleReferenceNodeProperty.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */