/*     */ package com.sun.xml.bind.v2.runtime.reflect.opt;
/*     */ 
/*     */ import com.sun.xml.bind.Util;
/*     */ import com.sun.xml.bind.v2.bytecode.ClassTailor;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.Accessor;
/*     */ import java.lang.reflect.Field;
/*     */ import java.lang.reflect.Method;
/*     */ import java.lang.reflect.Modifier;
/*     */ import java.util.logging.Level;
/*     */ import java.util.logging.Logger;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class OptimizedAccessorFactory
/*     */ {
/*  21 */   private static final Logger logger = ;
/*     */   
/*     */   private static final String fieldTemplateName;
/*     */   private static final String methodTemplateName;
/*     */   
/*     */   static
/*     */   {
/*  28 */     String s = FieldAccessor_Byte.class.getName();
/*  29 */     fieldTemplateName = s.substring(0, s.length() - "Byte".length()).replace('.', '/');
/*     */     
/*  31 */     s = MethodAccessor_Byte.class.getName();
/*  32 */     methodTemplateName = s.substring(0, s.length() - "Byte".length()).replace('.', '/');
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static final <B, V> Accessor<B, V> get(Method getter, Method setter)
/*     */   {
/*  43 */     if (getter.getParameterTypes().length != 0)
/*  44 */       return null;
/*  45 */     Class<?>[] sparams = setter.getParameterTypes();
/*  46 */     if (sparams.length != 1)
/*  47 */       return null;
/*  48 */     if (sparams[0] != getter.getReturnType())
/*  49 */       return null;
/*  50 */     if (setter.getReturnType() != Void.TYPE)
/*  51 */       return null;
/*  52 */     if (getter.getDeclaringClass() != setter.getDeclaringClass())
/*  53 */       return null;
/*  54 */     if ((Modifier.isPrivate(getter.getModifiers())) || (Modifier.isPrivate(setter.getModifiers())))
/*     */     {
/*  56 */       return null;
/*     */     }
/*     */     
/*  59 */     Class t = sparams[0];
/*  60 */     String typeName = t.getName().replace('.', '_');
/*     */     
/*  62 */     String newClassName = ClassTailor.toVMClassName(getter.getDeclaringClass()) + "$JaxbAccessorM_" + getter.getName() + '_' + setter.getName() + '_' + typeName;
/*     */     
/*     */     Class opt;
/*     */     Class opt;
/*  66 */     if (t.isPrimitive()) {
/*  67 */       opt = AccessorInjector.prepare(getter.getDeclaringClass(), methodTemplateName + t.getName(), newClassName, new String[] { ClassTailor.toVMClassName(Bean.class), ClassTailor.toVMClassName(getter.getDeclaringClass()), "get_" + t.getName(), getter.getName(), "set_" + t.getName(), setter.getName() });
/*     */ 
/*     */ 
/*     */ 
/*     */     }
/*     */     else
/*     */     {
/*     */ 
/*     */ 
/*     */ 
/*  77 */       opt = AccessorInjector.prepare(getter.getDeclaringClass(), methodTemplateName + "Ref", newClassName, new String[] { ClassTailor.toVMClassName(Bean.class), ClassTailor.toVMClassName(getter.getDeclaringClass()), ClassTailor.toVMClassName(Ref.class), ClassTailor.toVMClassName(t), "()" + ClassTailor.toVMTypeName(Ref.class), "()" + ClassTailor.toVMTypeName(t), '(' + ClassTailor.toVMTypeName(Ref.class) + ")V", '(' + ClassTailor.toVMTypeName(t) + ")V", "get_ref", getter.getName(), "set_ref", setter.getName() });
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  93 */     if (opt == null) {
/*  94 */       return null;
/*     */     }
/*  96 */     Accessor<B, V> acc = instanciate(opt);
/*  97 */     if (acc != null)
/*  98 */       logger.log(Level.FINE, "Using optimized Accessor for " + getter + " and " + setter);
/*  99 */     return acc;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static final <B, V> Accessor<B, V> get(Field field)
/*     */   {
/* 110 */     int mods = field.getModifiers();
/* 111 */     if ((Modifier.isPrivate(mods)) || (Modifier.isFinal(mods)))
/*     */     {
/* 113 */       return null;
/*     */     }
/* 115 */     String newClassName = ClassTailor.toVMClassName(field.getDeclaringClass()) + "$JaxbAccessorF_" + field.getName();
/*     */     
/*     */     Class opt;
/*     */     Class opt;
/* 119 */     if (field.getType().isPrimitive()) {
/* 120 */       opt = AccessorInjector.prepare(field.getDeclaringClass(), fieldTemplateName + field.getType().getName(), newClassName, new String[] { ClassTailor.toVMClassName(Bean.class), ClassTailor.toVMClassName(field.getDeclaringClass()), "f_" + field.getType().getName(), field.getName() });
/*     */ 
/*     */ 
/*     */     }
/*     */     else
/*     */     {
/*     */ 
/*     */ 
/* 128 */       opt = AccessorInjector.prepare(field.getDeclaringClass(), fieldTemplateName + "Ref", newClassName, new String[] { ClassTailor.toVMClassName(Bean.class), ClassTailor.toVMClassName(field.getDeclaringClass()), ClassTailor.toVMClassName(Ref.class), ClassTailor.toVMClassName(field.getType()), ClassTailor.toVMTypeName(Ref.class), ClassTailor.toVMTypeName(field.getType()), "f_ref", field.getName() });
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 140 */     if (opt == null) {
/* 141 */       return null;
/*     */     }
/* 143 */     Accessor<B, V> acc = instanciate(opt);
/* 144 */     if (acc != null)
/* 145 */       logger.log(Level.FINE, "Using optimized Accessor for " + field);
/* 146 */     return acc;
/*     */   }
/*     */   
/*     */   private static <B, V> Accessor<B, V> instanciate(Class opt) {
/*     */     try {
/* 151 */       return (Accessor)opt.newInstance();
/*     */     } catch (InstantiationException e) {
/* 153 */       logger.log(Level.INFO, "failed to load an optimized Accessor", e);
/*     */     } catch (IllegalAccessException e) {
/* 155 */       logger.log(Level.INFO, "failed to load an optimized Accessor", e);
/*     */     } catch (SecurityException e) {
/* 157 */       logger.log(Level.INFO, "failed to load an optimized Accessor", e);
/*     */     }
/* 159 */     return null;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\reflect\opt\OptimizedAccessorFactory.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */