/*     */ package net.rubyeye.xmemcached.monitor;
/*     */ 
/*     */ import java.util.HashMap;
/*     */ import java.util.Map;
/*     */ import java.util.concurrent.atomic.AtomicLong;
/*     */ import net.rubyeye.xmemcached.command.CommandType;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class StatisticsHandler
/*     */   implements StatisticsHandlerMBean
/*     */ {
/*  38 */   private Map<CommandType, AtomicLong> counterMap = new HashMap();
/*     */   
/*     */   public StatisticsHandler() {
/*  41 */     buildCounterMap();
/*  42 */     XMemcachedMbeanServer.getInstance().registMBean(this, getClass().getPackage().getName() + ":type=" + getClass().getSimpleName() + "-" + MemcachedClientNameHolder.getName());
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  49 */   private boolean statistics = Boolean.valueOf(System.getProperty("xmemcached.statistics.enable", "false")).booleanValue();
/*     */   
/*     */   private void buildCounterMap()
/*     */   {
/*  53 */     if (this.statistics) {
/*  54 */       Map<CommandType, AtomicLong> map = new HashMap();
/*  55 */       map.put(CommandType.APPEND, new AtomicLong());
/*  56 */       map.put(CommandType.SET, new AtomicLong());
/*  57 */       map.put(CommandType.PREPEND, new AtomicLong());
/*  58 */       map.put(CommandType.CAS, new AtomicLong());
/*  59 */       map.put(CommandType.ADD, new AtomicLong());
/*  60 */       map.put(CommandType.REPLACE, new AtomicLong());
/*  61 */       map.put(CommandType.DELETE, new AtomicLong());
/*  62 */       map.put(CommandType.INCR, new AtomicLong());
/*  63 */       map.put(CommandType.DECR, new AtomicLong());
/*  64 */       map.put(CommandType.GET_HIT, new AtomicLong());
/*  65 */       map.put(CommandType.GET_MISS, new AtomicLong());
/*  66 */       map.put(CommandType.GET_MANY, new AtomicLong());
/*  67 */       map.put(CommandType.GETS_MANY, new AtomicLong());
/*  68 */       this.counterMap = map;
/*     */     }
/*     */   }
/*     */   
/*     */   public final boolean isStatistics() {
/*  73 */     return this.statistics;
/*     */   }
/*     */   
/*     */   public final void statistics(CommandType cmdType) {
/*  77 */     if ((this.statistics) && (this.counterMap.get(cmdType) != null)) {
/*  78 */       ((AtomicLong)this.counterMap.get(cmdType)).incrementAndGet();
/*     */     }
/*     */   }
/*     */   
/*     */   public final void statistics(CommandType cmdType, int count) {
/*  83 */     if ((this.statistics) && (this.counterMap.get(cmdType) != null)) {
/*  84 */       ((AtomicLong)this.counterMap.get(cmdType)).addAndGet(count);
/*     */     }
/*     */   }
/*     */   
/*     */   public final void setStatistics(boolean statistics) {
/*  89 */     this.statistics = statistics;
/*  90 */     buildCounterMap();
/*     */   }
/*     */   
/*     */   public long getAppendCount()
/*     */   {
/*  95 */     return ((AtomicLong)this.counterMap.get(CommandType.APPEND)).get();
/*     */   }
/*     */   
/*     */   public long getCASCount() {
/*  99 */     return ((AtomicLong)this.counterMap.get(CommandType.CAS)).get();
/*     */   }
/*     */   
/*     */   public long getDecrCount() {
/* 103 */     return ((AtomicLong)this.counterMap.get(CommandType.DECR)).get();
/*     */   }
/*     */   
/*     */   public long getDeleteCount() {
/* 107 */     return ((AtomicLong)this.counterMap.get(CommandType.DELETE)).get();
/*     */   }
/*     */   
/*     */   public long getGetHitCount() {
/* 111 */     return ((AtomicLong)this.counterMap.get(CommandType.GET_HIT)).get();
/*     */   }
/*     */   
/*     */   public long getGetMissCount() {
/* 115 */     return ((AtomicLong)this.counterMap.get(CommandType.GET_MISS)).get();
/*     */   }
/*     */   
/*     */   public long getIncrCount() {
/* 119 */     return ((AtomicLong)this.counterMap.get(CommandType.INCR)).get();
/*     */   }
/*     */   
/*     */   public long getMultiGetCount() {
/* 123 */     return ((AtomicLong)this.counterMap.get(CommandType.GET_MANY)).get();
/*     */   }
/*     */   
/*     */   public long getMultiGetsCount() {
/* 127 */     return ((AtomicLong)this.counterMap.get(CommandType.GETS_MANY)).get();
/*     */   }
/*     */   
/*     */   public long getPrependCount() {
/* 131 */     return ((AtomicLong)this.counterMap.get(CommandType.PREPEND)).get();
/*     */   }
/*     */   
/*     */   public long getSetCount() {
/* 135 */     return ((AtomicLong)this.counterMap.get(CommandType.SET)).get();
/*     */   }
/*     */   
/*     */   public long getAddCount() {
/* 139 */     return ((AtomicLong)this.counterMap.get(CommandType.ADD)).get();
/*     */   }
/*     */   
/*     */   public long getReplaceCount() {
/* 143 */     return ((AtomicLong)this.counterMap.get(CommandType.REPLACE)).get();
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\monitor\StatisticsHandler.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */