/*    */ package com.google.code.yanf4j.util;
/*    */ 
/*    */ import com.google.code.yanf4j.buffer.IoBuffer;
/*    */ import java.util.ArrayList;
/*    */ import java.util.List;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class ShiftAndByteBufferMatcher
/*    */   implements ByteBufferMatcher
/*    */ {
/*    */   private int[] b;
/*    */   private int mask;
/*    */   private int patternLimit;
/*    */   private int patternPos;
/*    */   private int patternLen;
/*    */   
/*    */   public ShiftAndByteBufferMatcher(IoBuffer pat)
/*    */   {
/* 46 */     if ((pat == null) || (pat.remaining() == 0)) {
/* 47 */       throw new IllegalArgumentException("blank buffer");
/*    */     }
/* 49 */     this.patternLimit = pat.limit();
/* 50 */     this.patternPos = pat.position();
/* 51 */     this.patternLen = pat.remaining();
/* 52 */     preprocess(pat);
/* 53 */     this.mask = (1 << this.patternLen - 1);
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   private void preprocess(IoBuffer pat)
/*    */   {
/* 62 */     this.b = new int['Ā'];
/* 63 */     for (int i = this.patternPos; i < this.patternLimit; i++) {
/* 64 */       int p = ByteBufferUtils.uByte(pat.get(i));
/* 65 */       this.b[p] |= 1 << i;
/*    */     }
/*    */   }
/*    */   
/*    */   public final List<Integer> matchAll(IoBuffer buffer) {
/* 70 */     List<Integer> matches = new ArrayList();
/* 71 */     int bufferLimit = buffer.limit();
/* 72 */     int d = 0;
/* 73 */     for (int pos = buffer.position(); pos < bufferLimit; pos++) {
/* 74 */       d <<= 1;
/* 75 */       d |= 0x1;
/* 76 */       d &= this.b[ByteBufferUtils.uByte(buffer.get(pos))];
/* 77 */       if ((d & this.mask) != 0) {
/* 78 */         matches.add(Integer.valueOf(pos - this.patternLen + 1));
/*    */       }
/*    */     }
/* 81 */     return matches;
/*    */   }
/*    */   
/*    */   public final int matchFirst(IoBuffer buffer) {
/* 85 */     if (buffer == null) {
/* 86 */       return -1;
/*    */     }
/* 88 */     int bufferLimit = buffer.limit();
/* 89 */     int d = 0;
/* 90 */     for (int pos = buffer.position(); pos < bufferLimit; pos++) {
/* 91 */       d <<= 1;
/* 92 */       d |= 0x1;
/* 93 */       d &= this.b[ByteBufferUtils.uByte(buffer.get(pos))];
/* 94 */       if ((d & this.mask) != 0) {
/* 95 */         return pos - this.patternLen + 1;
/*    */       }
/*    */     }
/* 98 */     return -1;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\google\code\yanf4j\util\ShiftAndByteBufferMatcher.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */