/*    */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.reporting.reportparameters;
/*    */ 
/*    */ import com.jaspersoft.jasperserver.dto.reports.ReportParameter;
/*    */ import com.jaspersoft.jasperserver.dto.reports.ReportParameters;
/*    */ import com.jaspersoft.jasperserver.dto.reports.inputcontrols.InputControlOption;
/*    */ import com.jaspersoft.jasperserver.dto.reports.inputcontrols.InputControlState;
/*    */ import java.util.ArrayList;
/*    */ import java.util.Arrays;
/*    */ import java.util.HashMap;
/*    */ import java.util.List;
/*    */ import java.util.Map;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class ReportParametersConverter
/*    */ {
/*    */   public static Map<String, Object> getValueMapFromInputControlStates(List<InputControlState> states)
/*    */   {
/* 34 */     Map<String, Object> valueMap = new HashMap(states.size());
/* 35 */     for (InputControlState state : states) {
/* 36 */       if (state != null) {
/* 37 */         valueMap.put(state.getId(), getValueFromInputControlState(state));
/*    */       }
/*    */     }
/* 40 */     return valueMap;
/*    */   }
/*    */   
/*    */   public static ReportParameters toReportParameters(List<InputControlState> states) {
/* 44 */     List<ReportParameter> reportParameterList = new ArrayList();
/* 45 */     for (InputControlState inputControlState : states) {
/* 46 */       ReportParameter parameter = new ReportParameter();
/* 47 */       parameter.setName(inputControlState.getId());
/* 48 */       parameter.setValues(Arrays.asList(getValueFromInputControlState(inputControlState)));
/*    */       
/* 50 */       reportParameterList.add(parameter);
/*    */     }
/* 52 */     return new ReportParameters(reportParameterList);
/*    */   }
/*    */   
/*    */   protected static String[] getValueFromInputControlState(InputControlState state) {
/* 56 */     if (state.getValue() != null)
/* 57 */       return new String[] { state.getValue() };
/* 58 */     if (state.getOptions() != null) {
/* 59 */       List<String> values = new ArrayList(state.getOptions().size());
/* 60 */       for (InputControlOption option : state.getOptions()) {
/* 61 */         if (option.isSelected()) {
/* 62 */           values.add(option.getValue());
/*    */         }
/*    */       }
/* 65 */       return (String[])values.toArray(new String[values.size()]);
/*    */     }
/* 67 */     return new String[0];
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\reporting\reportparameters\ReportParametersConverter.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */