/*    */ package com.netapp.asup.data.objects;
/*    */ 
/*    */ import java.io.IOException;
/*    */ import java.nio.ByteBuffer;
/*    */ import java.util.HashMap;
/*    */ import java.util.Map;
/*    */ import java.util.Set;
/*    */ import org.apache.avro.Schema;
/*    */ import org.apache.avro.generic.GenericRecord;
/*    */ import org.apache.avro.util.Utf8;
/*    */ 
/*    */ 
/*    */ public class FunctionData
/*    */   extends ByteWrappedGenericRecord<GenericRecord, Map<Utf8, ByteBuffer>>
/*    */ {
/* 16 */   private Map<Utf8, GenericRecord> functionOutput = new HashMap();
/*    */   
/*    */   public FunctionData(Map<Utf8, ByteBuffer> input, Schema outputSchema, String id) {
/* 19 */     super(ARMASchema.FUNCTION_DATA_INSTANCE, outputSchema, id);
/* 20 */     this.object = input;
/*    */   }
/*    */   
/*    */   public FunctionData(Schema outputSchema, String id) {
/* 24 */     super(ARMASchema.FUNCTION_DATA, outputSchema, id);
/*    */   }
/*    */   
/*    */   public void addFunctionOutput(Utf8 key, GenericRecord value) {
/* 28 */     if (value != null) {
/* 29 */       this.functionOutput.put(key, value);
/*    */     }
/*    */   }
/*    */   
/*    */   public GenericRecord getFunctionOutputForInstance(Utf8 key) throws IOException
/*    */   {
/* 35 */     GenericRecord funcGenericRecord = (GenericRecord)this.functionOutput.get(key);
/* 36 */     if (null == funcGenericRecord)
/*    */     {
/* 38 */       ByteBuffer byteBuffer = (ByteBuffer)((Map)this.object).get(key);
/* 39 */       funcGenericRecord = (GenericRecord)deserializeData(byteBuffer.array());
/* 40 */       this.functionOutput.put(key, funcGenericRecord);
/*    */     }
/* 42 */     return funcGenericRecord;
/*    */   }
/*    */   
/*    */   public Map<Utf8, GenericRecord> getFunctionOutput() throws IOException
/*    */   {
/* 47 */     if ((this.functionOutput.isEmpty()) && (null != this.object))
/*    */     {
/* 49 */       Set<Utf8> instanceKeys = ((Map)this.object).keySet();
/* 50 */       for (Utf8 instanceKey : instanceKeys) {
/* 51 */         this.functionOutput.put(instanceKey, getFunctionOutputForInstance(instanceKey));
/*    */       }
/*    */     }
/* 54 */     return this.functionOutput;
/*    */   }
/*    */   
/*    */   public Map<Utf8, ByteBuffer> getObject() throws IOException
/*    */   {
/* 59 */     return serializeMap(this.functionOutput);
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\objects\FunctionData.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */