/*    */ package com.netapp.asup.data.utils;
/*    */ 
/*    */ import com.netapp.asup.common.AsupLogger;
/*    */ import java.io.IOException;
/*    */ import java.io.InputStream;
/*    */ import java.util.Properties;
/*    */ 
/*    */ 
/*    */ public class PropertyFileReader
/*    */ {
/* 11 */   private static final AsupLogger LOGGER = AsupLogger.getLogger(PropertyFileReader.class);
/*    */   
/*    */ 
/* 14 */   private static final PropertyFileReader reader = new PropertyFileReader();
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */   public static PropertyFileReader getInstance()
/*    */   {
/* 21 */     return reader;
/*    */   }
/*    */   
/*    */ 
/*    */   public Properties getPropertiesFromResource(String asupId, String resourcePath)
/*    */   {
/* 27 */     props = new Properties();
/*    */     
/* 29 */     InputStream resourceAsStream = PropertyFileReader.class.getClassLoader().getResourceAsStream(resourcePath);
/*    */     
/*    */ 
/* 32 */     if (null == resourceAsStream) {
/* 33 */       LOGGER.warn(asupId, "The configuration resource is not avaialble:" + resourcePath);
/*    */       
/* 35 */       return props;
/*    */     }
/*    */     try
/*    */     {
/* 39 */       props.load(resourceAsStream);
/*    */       
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/* 54 */       return props;
/*    */     }
/*    */     catch (IOException e)
/*    */     {
/* 41 */       LOGGER.warn(asupId, "Error loading the configuration resource:" + resourcePath);
/*    */     }
/*    */     finally {
/* 44 */       if (null != resourceAsStream) {
/*    */         try {
/* 46 */           resourceAsStream.close();
/*    */         } catch (IOException e) {
/* 48 */           LOGGER.warn(asupId, "Error closing the configuration resource stream:" + resourcePath);
/*    */         }
/*    */       }
/*    */     }
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\utils\PropertyFileReader.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */