/*    */ package com.sun.xml.bind.v2.model.nav;
/*    */ 
/*    */ import java.lang.reflect.GenericArrayType;
/*    */ import java.lang.reflect.ParameterizedType;
/*    */ import java.lang.reflect.Type;
/*    */ import java.lang.reflect.TypeVariable;
/*    */ import java.lang.reflect.WildcardType;
/*    */ 
/*    */ 
/*    */ abstract class TypeVisitor<T, P>
/*    */ {
/*    */   public final T visit(Type t, P param)
/*    */   {
/* 14 */     assert (t != null);
/*    */     
/* 16 */     if ((t instanceof Class))
/* 17 */       return (T)onClass((Class)t, param);
/* 18 */     if ((t instanceof ParameterizedType))
/* 19 */       return (T)onParameterizdType((ParameterizedType)t, param);
/* 20 */     if ((t instanceof GenericArrayType))
/* 21 */       return (T)onGenericArray((GenericArrayType)t, param);
/* 22 */     if ((t instanceof WildcardType))
/* 23 */       return (T)onWildcard((WildcardType)t, param);
/* 24 */     if ((t instanceof TypeVariable)) {
/* 25 */       return (T)onVariable((TypeVariable)t, param);
/*    */     }
/*    */     
/* 28 */     if (!$assertionsDisabled) throw new AssertionError();
/* 29 */     throw new IllegalArgumentException();
/*    */   }
/*    */   
/*    */   protected abstract T onClass(Class paramClass, P paramP);
/*    */   
/*    */   protected abstract T onParameterizdType(ParameterizedType paramParameterizedType, P paramP);
/*    */   
/*    */   protected abstract T onGenericArray(GenericArrayType paramGenericArrayType, P paramP);
/*    */   
/*    */   protected abstract T onVariable(TypeVariable paramTypeVariable, P paramP);
/*    */   
/*    */   protected abstract T onWildcard(WildcardType paramWildcardType, P paramP);
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\model\nav\TypeVisitor.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */