/*    */ package net.rubyeye.xmemcached.auth;
/*    */ 
/*    */ import javax.security.auth.callback.CallbackHandler;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class AuthInfo
/*    */ {
/*    */   private final CallbackHandler callbackHandler;
/*    */   private final String[] mechanisms;
/* 14 */   private final int maxAttempts = Integer.parseInt(System.getProperty("net.rubyeye.xmemcached.auth_max_attempts", "-1"));
/*    */   private int attempts;
/*    */   
/*    */   public synchronized boolean isValid()
/*    */   {
/* 19 */     return (this.attempts <= this.maxAttempts) || (this.maxAttempts < 0);
/*    */   }
/*    */   
/*    */   public synchronized boolean isFirstTime() {
/* 23 */     return this.attempts == 0;
/*    */   }
/*    */   
/*    */   public synchronized void increaseAttempts() {
/* 27 */     this.attempts += 1;
/*    */   }
/*    */   
/*    */   public AuthInfo(CallbackHandler callbackHandler, String[] mechanisms)
/*    */   {
/* 32 */     this.callbackHandler = callbackHandler;
/* 33 */     this.mechanisms = mechanisms;
/*    */   }
/*    */   
/*    */   public int getMaxAttempts() {
/* 37 */     return this.maxAttempts;
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   public static AuthInfo plain(String username, String password)
/*    */   {
/* 52 */     return new AuthInfo(new PlainCallbackHandler(username, password), new String[] { "PLAIN" });
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   public static AuthInfo cramMD5(String username, String password)
/*    */   {
/* 68 */     return new AuthInfo(new PlainCallbackHandler(username, password), new String[] { "CRAM-MD5" });
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   public static AuthInfo typical(String username, String password)
/*    */   {
/* 84 */     return new AuthInfo(new PlainCallbackHandler(username, password), new String[] { "CRAM-MD5", "PLAIN" });
/*    */   }
/*    */   
/*    */   public CallbackHandler getCallbackHandler()
/*    */   {
/* 89 */     return this.callbackHandler;
/*    */   }
/*    */   
/*    */   public String[] getMechanisms() {
/* 93 */     return this.mechanisms;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\auth\AuthInfo.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */