/*    */ package net.rubyeye.xmemcached.codec;
/*    */ 
/*    */ import com.google.code.yanf4j.buffer.IoBuffer;
/*    */ import com.google.code.yanf4j.core.CodecFactory.Decoder;
/*    */ import com.google.code.yanf4j.core.Session;
/*    */ import com.google.code.yanf4j.util.ByteBufferMatcher;
/*    */ import com.google.code.yanf4j.util.ShiftAndByteBufferMatcher;
/*    */ import net.rubyeye.xmemcached.command.Command;
/*    */ import net.rubyeye.xmemcached.impl.MemcachedTCPSession;
/*    */ import net.rubyeye.xmemcached.utils.ByteUtils;
/*    */ import org.slf4j.Logger;
/*    */ import org.slf4j.LoggerFactory;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class MemcachedDecoder
/*    */   implements CodecFactory.Decoder
/*    */ {
/* 35 */   public static final Logger log = LoggerFactory.getLogger(MemcachedDecoder.class);
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/* 45 */   public static final ByteBufferMatcher SPLIT_MATCHER = new ShiftAndByteBufferMatcher(IoBuffer.wrap(ByteUtils.SPLIT));
/*    */   
/*    */   public Object decode(IoBuffer buffer, Session origSession)
/*    */   {
/* 49 */     MemcachedTCPSession session = (MemcachedTCPSession)origSession;
/* 50 */     if (session.getCurrentCommand() != null) {
/* 51 */       return decode0(buffer, session);
/*    */     }
/* 53 */     session.takeCurrentCommand();
/* 54 */     if (session.getCurrentCommand() == null)
/* 55 */       return null;
/* 56 */     return decode0(buffer, session);
/*    */   }
/*    */   
/*    */   private Object decode0(IoBuffer buffer, MemcachedTCPSession session)
/*    */   {
/* 61 */     if (session.getCurrentCommand().decode(session, buffer.buf())) {
/* 62 */       Command command = session.getCurrentCommand();
/* 63 */       session.setCurrentCommand(null);
/* 64 */       return command;
/*    */     }
/* 66 */     return null;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\codec\MemcachedDecoder.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */