/*     */ package net.rubyeye.xmemcached.command.text;
/*     */ 
/*     */ import com.google.code.yanf4j.buffer.IoBuffer;
/*     */ import java.nio.ByteBuffer;
/*     */ import java.util.concurrent.CountDownLatch;
/*     */ import net.rubyeye.xmemcached.command.Command;
/*     */ import net.rubyeye.xmemcached.command.CommandType;
/*     */ import net.rubyeye.xmemcached.impl.MemcachedTCPSession;
/*     */ import net.rubyeye.xmemcached.monitor.Constants;
/*     */ import net.rubyeye.xmemcached.utils.ByteUtils;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class TextDeleteCommand
/*     */   extends Command
/*     */ {
/*     */   protected int time;
/*     */   
/*     */   public TextDeleteCommand(String key, byte[] keyBytes, int time, CountDownLatch latch, boolean noreply)
/*     */   {
/*  48 */     super(key, keyBytes, latch);
/*  49 */     this.commandType = CommandType.DELETE;
/*  50 */     this.time = time;
/*  51 */     this.noreply = noreply;
/*     */   }
/*     */   
/*     */   public final int getTime() {
/*  55 */     return this.time;
/*     */   }
/*     */   
/*     */   public final void setTime(int time) {
/*  59 */     this.time = time;
/*     */   }
/*     */   
/*     */   public boolean decode(MemcachedTCPSession session, ByteBuffer buffer)
/*     */   {
/*  64 */     if ((buffer == null) || (!buffer.hasRemaining())) {
/*  65 */       return false;
/*     */     }
/*  67 */     if (this.result == null) {
/*  68 */       byte first = buffer.get(buffer.position());
/*  69 */       if (first == 68) {
/*  70 */         setResult(Boolean.TRUE);
/*  71 */         countDownLatch();
/*     */         
/*  73 */         return ByteUtils.stepBuffer(buffer, 9); }
/*  74 */       if (first == 78) {
/*  75 */         setResult(Boolean.FALSE);
/*  76 */         countDownLatch();
/*     */         
/*  78 */         return ByteUtils.stepBuffer(buffer, 11);
/*     */       }
/*  80 */       return decodeError(session, buffer);
/*     */     }
/*     */     
/*  83 */     Boolean result = (Boolean)this.result;
/*  84 */     if (result.booleanValue()) {
/*  85 */       return ByteUtils.stepBuffer(buffer, 9);
/*     */     }
/*  87 */     return ByteUtils.stepBuffer(buffer, 11);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public final void encode()
/*     */   {
/*  94 */     int size = Constants.DELETE.length + 1 + this.keyBytes.length + Constants.CRLF.length;
/*     */     
/*  96 */     if (isNoreply()) {
/*  97 */       size += 8;
/*     */     }
/*  99 */     byte[] buf = new byte[size];
/* 100 */     if (isNoreply()) {
/* 101 */       ByteUtils.setArguments(buf, 0, new Object[] { Constants.DELETE, this.keyBytes, Constants.NO_REPLY });
/*     */     }
/*     */     else {
/* 104 */       ByteUtils.setArguments(buf, 0, new Object[] { Constants.DELETE, this.keyBytes });
/*     */     }
/* 106 */     this.ioBuffer = IoBuffer.wrap(buf);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\command\text\TextDeleteCommand.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */