/*     */ package net.rubyeye.xmemcached.command.text;
/*     */ 
/*     */ import com.google.code.yanf4j.buffer.IoBuffer;
/*     */ import java.nio.ByteBuffer;
/*     */ import java.util.concurrent.CountDownLatch;
/*     */ import net.rubyeye.xmemcached.command.Command;
/*     */ import net.rubyeye.xmemcached.command.CommandType;
/*     */ import net.rubyeye.xmemcached.impl.MemcachedTCPSession;
/*     */ import net.rubyeye.xmemcached.monitor.Constants;
/*     */ import net.rubyeye.xmemcached.utils.ByteUtils;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class TextFlushAllCommand
/*     */   extends Command
/*     */ {
/*  44 */   public static final ByteBuffer FLUSH_ALL = ByteBuffer.wrap("flush_all\r\n".getBytes());
/*     */   
/*     */   protected int exptime;
/*     */   
/*     */   public final int getExptime()
/*     */   {
/*  50 */     return this.exptime;
/*     */   }
/*     */   
/*     */   public TextFlushAllCommand(CountDownLatch latch, int delay, boolean noreply)
/*     */   {
/*  55 */     super("[flush_all]", (byte[])null, latch);
/*  56 */     this.commandType = CommandType.FLUSH_ALL;
/*  57 */     this.exptime = delay;
/*  58 */     this.noreply = noreply;
/*     */   }
/*     */   
/*     */   public boolean decode(MemcachedTCPSession session, ByteBuffer buffer)
/*     */   {
/*  63 */     if ((buffer == null) || (!buffer.hasRemaining())) {
/*  64 */       return false;
/*     */     }
/*  66 */     if (this.result == null) {
/*  67 */       byte first = buffer.get(buffer.position());
/*  68 */       if (first == 79) {
/*  69 */         setResult(Boolean.TRUE);
/*  70 */         countDownLatch();
/*     */         
/*  72 */         return ByteUtils.stepBuffer(buffer, 4);
/*     */       }
/*  74 */       return decodeError(session, buffer);
/*     */     }
/*     */     
/*  77 */     return ByteUtils.stepBuffer(buffer, 4);
/*     */   }
/*     */   
/*     */ 
/*     */   public final void encode()
/*     */   {
/*  83 */     if (isNoreply()) {
/*  84 */       if (this.exptime <= 0) {
/*  85 */         this.ioBuffer = IoBuffer.allocate("flush_all".length() + 1 + Constants.NO_REPLY.length + 2);
/*     */         
/*  87 */         ByteUtils.setArguments(this.ioBuffer, new Object[] { "flush_all", Constants.NO_REPLY });
/*     */       }
/*     */       else {
/*  90 */         byte[] delayBytes = ByteUtils.getBytes(String.valueOf(this.exptime));
/*     */         
/*  92 */         this.ioBuffer = IoBuffer.allocate("flush_all".length() + 2 + delayBytes.length + Constants.NO_REPLY.length + 2);
/*     */         
/*  94 */         ByteUtils.setArguments(this.ioBuffer, new Object[] { "flush_all", delayBytes, Constants.NO_REPLY });
/*     */       }
/*     */       
/*  97 */       this.ioBuffer.flip();
/*     */     }
/*  99 */     else if (this.exptime <= 0) {
/* 100 */       this.ioBuffer = IoBuffer.wrap(FLUSH_ALL.slice());
/*     */     }
/*     */     else {
/* 103 */       byte[] delayBytes = ByteUtils.getBytes(String.valueOf(this.exptime));
/*     */       
/* 105 */       this.ioBuffer = IoBuffer.allocate("flush_all".length() + 1 + delayBytes.length + 2);
/*     */       
/* 107 */       ByteUtils.setArguments(this.ioBuffer, new Object[] { "flush_all", delayBytes });
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\command\text\TextFlushAllCommand.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */