/*    */ package org.codehaus.jackson.map.deser;
/*    */ 
/*    */ import java.lang.reflect.Constructor;
/*    */ import java.lang.reflect.Method;
/*    */ import java.util.HashMap;
/*    */ import org.codehaus.jackson.map.DeserializationConfig;
/*    */ import org.codehaus.jackson.map.KeyDeserializer;
/*    */ import org.codehaus.jackson.map.introspect.BasicBeanDescription;
/*    */ import org.codehaus.jackson.map.type.TypeFactory;
/*    */ import org.codehaus.jackson.type.JavaType;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ class StdKeyDeserializers
/*    */ {
/* 27 */   final HashMap<JavaType, KeyDeserializer> _keyDeserializers = new HashMap();
/*    */   
/*    */   private StdKeyDeserializers()
/*    */   {
/* 31 */     add(new StdKeyDeserializer.BoolKD());
/* 32 */     add(new StdKeyDeserializer.ByteKD());
/* 33 */     add(new StdKeyDeserializer.CharKD());
/* 34 */     add(new StdKeyDeserializer.ShortKD());
/* 35 */     add(new StdKeyDeserializer.IntKD());
/* 36 */     add(new StdKeyDeserializer.LongKD());
/* 37 */     add(new StdKeyDeserializer.FloatKD());
/* 38 */     add(new StdKeyDeserializer.DoubleKD());
/*    */   }
/*    */   
/*    */   private void add(StdKeyDeserializer kdeser)
/*    */   {
/* 43 */     Class<?> keyClass = kdeser.getKeyClass();
/*    */     
/*    */ 
/*    */ 
/* 47 */     this._keyDeserializers.put(TypeFactory.defaultInstance().constructType(keyClass), kdeser);
/*    */   }
/*    */   
/*    */   public static HashMap<JavaType, KeyDeserializer> constructAll()
/*    */   {
/* 52 */     return new StdKeyDeserializers()._keyDeserializers;
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   public static KeyDeserializer constructEnumKeyDeserializer(DeserializationConfig config, JavaType type)
/*    */   {
/* 63 */     EnumResolver<?> er = EnumResolver.constructUnsafe(type.getRawClass(), config.getAnnotationIntrospector());
/* 64 */     return new StdKeyDeserializer.EnumKD(er);
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */   public static KeyDeserializer findStringBasedKeyDeserializer(DeserializationConfig config, JavaType type)
/*    */   {
/* 72 */     BasicBeanDescription beanDesc = (BasicBeanDescription)config.introspect(type);
/*    */     
/* 74 */     Constructor<?> ctor = beanDesc.findSingleArgConstructor(new Class[] { String.class });
/* 75 */     if (ctor != null) {
/* 76 */       return new StdKeyDeserializer.StringCtorKeyDeserializer(ctor);
/*    */     }
/*    */     
/*    */ 
/*    */ 
/* 81 */     Method m = beanDesc.findFactoryMethod(new Class[] { String.class });
/* 82 */     if (m != null) {
/* 83 */       return new StdKeyDeserializer.StringFactoryKeyDeserializer(m);
/*    */     }
/*    */     
/* 86 */     return null;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\deser\StdKeyDeserializers.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */