/*     */ package org.codehaus.jackson.node;
/*     */ 
/*     */ import java.math.BigDecimal;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import java.util.NoSuchElementException;
/*     */ import org.codehaus.jackson.JsonNode;
/*     */ import org.codehaus.jackson.JsonToken;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class ContainerNode
/*     */   extends BaseJsonNode
/*     */ {
/*     */   JsonNodeFactory _nodeFactory;
/*     */   
/*     */   protected ContainerNode(JsonNodeFactory nc)
/*     */   {
/*  27 */     this._nodeFactory = nc;
/*     */   }
/*     */   
/*     */   public boolean isContainerNode() {
/*  31 */     return true;
/*     */   }
/*     */   
/*     */   public abstract JsonToken asToken();
/*     */   
/*     */   public String getValueAsText() {
/*  37 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract JsonNode findValue(String paramString);
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract ObjectNode findParent(String paramString);
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract List<JsonNode> findValues(String paramString, List<JsonNode> paramList);
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract List<JsonNode> findParents(String paramString, List<JsonNode> paramList);
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract List<String> findValuesAsText(String paramString, List<String> paramList);
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract int size();
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract JsonNode get(int paramInt);
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract JsonNode get(String paramString);
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public final ArrayNode arrayNode()
/*     */   {
/*  86 */     return this._nodeFactory.arrayNode();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*  92 */   public final ObjectNode objectNode() { return this._nodeFactory.objectNode(); }
/*     */   
/*  94 */   public final NullNode nullNode() { return this._nodeFactory.nullNode(); }
/*     */   
/*  96 */   public final BooleanNode booleanNode(boolean v) { return this._nodeFactory.booleanNode(v); }
/*     */   
/*  98 */   public final NumericNode numberNode(byte v) { return this._nodeFactory.numberNode(v); }
/*  99 */   public final NumericNode numberNode(short v) { return this._nodeFactory.numberNode(v); }
/* 100 */   public final NumericNode numberNode(int v) { return this._nodeFactory.numberNode(v); }
/* 101 */   public final NumericNode numberNode(long v) { return this._nodeFactory.numberNode(v); }
/* 102 */   public final NumericNode numberNode(float v) { return this._nodeFactory.numberNode(v); }
/* 103 */   public final NumericNode numberNode(double v) { return this._nodeFactory.numberNode(v); }
/* 104 */   public final NumericNode numberNode(BigDecimal v) { return this._nodeFactory.numberNode(v); }
/*     */   
/* 106 */   public final TextNode textNode(String text) { return this._nodeFactory.textNode(text); }
/*     */   
/* 108 */   public final BinaryNode binaryNode(byte[] data) { return this._nodeFactory.binaryNode(data); }
/* 109 */   public final BinaryNode binaryNode(byte[] data, int offset, int length) { return this._nodeFactory.binaryNode(data, offset, length); }
/*     */   
/* 111 */   public final POJONode POJONode(Object pojo) { return this._nodeFactory.POJONode(pojo); }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract ContainerNode removeAll();
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected static class NoNodesIterator
/*     */     implements Iterator<JsonNode>
/*     */   {
/* 137 */     static final NoNodesIterator instance = new NoNodesIterator();
/*     */     
/*     */ 
/*     */ 
/* 141 */     public static NoNodesIterator instance() { return instance; }
/*     */     
/* 143 */     public boolean hasNext() { return false; }
/* 144 */     public JsonNode next() { throw new NoSuchElementException(); }
/*     */     
/*     */     public void remove()
/*     */     {
/* 148 */       throw new IllegalStateException();
/*     */     }
/*     */   }
/*     */   
/*     */   protected static class NoStringsIterator
/*     */     implements Iterator<String>
/*     */   {
/* 155 */     static final NoStringsIterator instance = new NoStringsIterator();
/*     */     
/*     */ 
/*     */ 
/* 159 */     public static NoStringsIterator instance() { return instance; }
/*     */     
/* 161 */     public boolean hasNext() { return false; }
/* 162 */     public String next() { throw new NoSuchElementException(); }
/*     */     
/*     */     public void remove()
/*     */     {
/* 166 */       throw new IllegalStateException();
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\node\ContainerNode.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */