package prefuse.action;

import java.util.logging.Logger;
import prefuse.Visualization;
import prefuse.activity.Activity;

public abstract class Action
  extends Activity
{
  private static final Logger s_logger = Logger.getLogger(Action.class.getName());
  protected Visualization m_vis;
  
  public Action()
  {
    this(null);
  }
  
  public Action(long paramLong)
  {
    super(paramLong, 15L);
  }
  
  public Action(long paramLong1, long paramLong2)
  {
    super(paramLong1, paramLong2);
  }
  
  public Action(Visualization paramVisualization)
  {
    this(paramVisualization, 0L);
  }
  
  public Action(Visualization paramVisualization, long paramLong)
  {
    super(paramLong, 15L);
    this.m_vis = paramVisualization;
  }
  
  public Action(Visualization paramVisualization, long paramLong1, long paramLong2)
  {
    super(paramLong1, paramLong2);
    this.m_vis = paramVisualization;
  }
  
  public abstract void run(double paramDouble);
  
  protected void run(long paramLong)
  {
    Visualization localVisualization = getVisualization();
    if (localVisualization != null)
    {
      synchronized (localVisualization)
      {
        run(getPace(paramLong));
      }
    }
    else
    {
      s_logger.info("Running unsynchronized Action");
      run(getPace(paramLong));
    }
  }
  
  public Visualization getVisualization()
  {
    return this.m_vis;
  }
  
  public void setVisualization(Visualization paramVisualization)
  {
    this.m_vis = paramVisualization;
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\action\Action.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */