package prefuse.data.expression;

import prefuse.data.Schema;
import prefuse.data.Tuple;

class SignFunction
  extends DoubleFunction
{
  public SignFunction()
  {
    super(1);
  }
  
  public String getName()
  {
    return "SIGN";
  }
  
  public Class getType(Schema paramSchema)
  {
    return Integer.TYPE;
  }
  
  public double getDouble(Tuple paramTuple)
  {
    return getInt(paramTuple);
  }
  
  public int getInt(Tuple paramTuple)
  {
    if (paramCount() == 1)
    {
      double d = param(0).getDouble(paramTuple);
      return d == 0.0D ? 0 : d < 0.0D ? -1 : 1;
    }
    missingParams();
    return Integer.MIN_VALUE;
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\data\expression\SignFunction.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */