package prefuse.data.query;

import java.util.ArrayList;
import javax.swing.DefaultListSelectionModel;
import javax.swing.MutableComboBoxModel;
import javax.swing.event.ListDataEvent;
import javax.swing.event.ListDataListener;
import prefuse.util.collections.CopyOnWriteArrayList;

public class ListModel
  extends DefaultListSelectionModel
  implements MutableComboBoxModel
{
  private ArrayList m_items = new ArrayList();
  private CopyOnWriteArrayList m_lstnrs = new CopyOnWriteArrayList();
  
  public ListModel() {}
  
  public ListModel(Object[] paramArrayOfObject)
  {
    for (int i = 0; i < paramArrayOfObject.length; i++) {
      this.m_items.add(paramArrayOfObject[i]);
    }
  }
  
  private boolean isMultipleSelection()
  {
    return getMaxSelectionIndex() - getMinSelectionIndex() > 0;
  }
  
  public Object getSelectedItem()
  {
    int i = getMinSelectionIndex();
    return i == -1 ? null : this.m_items.get(i);
  }
  
  public void setSelectedItem(Object paramObject)
  {
    int i = this.m_items.indexOf(paramObject);
    if (i < 0) {
      return;
    }
    if ((!isMultipleSelection()) && (i == getMinSelectionIndex())) {
      return;
    }
    super.setSelectionInterval(i, i);
    fireDataEvent(this, 0, -1, -1);
  }
  
  public int getSize()
  {
    return this.m_items.size();
  }
  
  public Object getElementAt(int paramInt)
  {
    return this.m_items.get(paramInt);
  }
  
  public void addElement(Object paramObject)
  {
    this.m_items.add(paramObject);
    int i = this.m_items.size() - 1;
    fireDataEvent(this, 1, i, i);
    if ((i >= 0) && (isSelectionEmpty()) && (paramObject != null)) {
      setSelectedItem(paramObject);
    }
  }
  
  public void insertElementAt(Object paramObject, int paramInt)
  {
    this.m_items.add(paramInt, paramObject);
    fireDataEvent(this, 1, paramInt, paramInt);
  }
  
  public void removeElement(Object paramObject)
  {
    int i = this.m_items.indexOf(paramObject);
    if (i >= 0) {
      removeElementAt(i);
    }
  }
  
  public void removeElementAt(int paramInt)
  {
    if ((!isMultipleSelection()) && (paramInt == getMinSelectionIndex()))
    {
      int i = paramInt == 0 ? paramInt + 1 : getSize() == 1 ? -1 : paramInt - 1;
      Object localObject = i == -1 ? null : this.m_items.get(i);
      setSelectedItem(localObject);
    }
    this.m_items.remove(paramInt);
    fireDataEvent(this, 2, paramInt, paramInt);
  }
  
  public void addListDataListener(ListDataListener paramListDataListener)
  {
    if (!this.m_lstnrs.contains(paramListDataListener)) {
      this.m_lstnrs.add(paramListDataListener);
    }
  }
  
  public void removeListDataListener(ListDataListener paramListDataListener)
  {
    this.m_lstnrs.remove(paramListDataListener);
  }
  
  protected void fireDataEvent(Object paramObject, int paramInt1, int paramInt2, int paramInt3)
  {
    Object[] arrayOfObject = this.m_lstnrs.getArray();
    if (arrayOfObject.length > 0)
    {
      ListDataEvent localListDataEvent = new ListDataEvent(paramObject, paramInt1, paramInt2, paramInt3);
      for (int i = 0; i < arrayOfObject.length; i++) {
        ((ListDataListener)arrayOfObject[i]).contentsChanged(localListDataEvent);
      }
    }
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\data\query\ListModel.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */