package prefuse.data.util;

import java.util.ConcurrentModificationException;
import java.util.Date;
import prefuse.data.Table;
import prefuse.util.collections.IntIterator;

public class TableIterator
  extends IntIterator
{
  private Table m_table;
  private IntIterator m_rows;
  private int m_modCount;
  protected int m_cur = -1;
  
  public TableIterator(Table paramTable, IntIterator paramIntIterator)
  {
    this.m_table = paramTable;
    this.m_rows = paramIntIterator;
    this.m_modCount = paramTable.getModificationCount();
  }
  
  public int nextInt()
  {
    if (this.m_modCount != this.m_table.getModificationCount()) {
      throw new ConcurrentModificationException();
    }
    this.m_cur = this.m_rows.nextInt();
    return this.m_cur;
  }
  
  public boolean hasNext()
  {
    return this.m_rows.hasNext();
  }
  
  public void remove()
  {
    if (this.m_table.removeRow(this.m_cur)) {
      modify();
    }
  }
  
  protected void modify()
  {
    this.m_modCount += 1;
    this.m_cur = -1;
  }
  
  public final boolean canGet(String paramString, Class paramClass)
  {
    return this.m_table.canGet(paramString, paramClass);
  }
  
  public final boolean canSet(String paramString, Class paramClass)
  {
    return this.m_table.canSet(paramString, paramClass);
  }
  
  public final Object get(String paramString)
  {
    return this.m_table.get(this.m_cur, paramString);
  }
  
  public final void set(String paramString, Object paramObject)
  {
    this.m_modCount += 1;
    this.m_table.set(this.m_cur, paramString, paramObject);
  }
  
  public final boolean canGetInt(String paramString)
  {
    return this.m_table.canGetInt(paramString);
  }
  
  public final boolean canSetInt(String paramString)
  {
    return this.m_table.canSetInt(paramString);
  }
  
  public final int getInt(String paramString)
  {
    return this.m_table.getInt(this.m_cur, paramString);
  }
  
  public final void setInt(String paramString, int paramInt)
  {
    this.m_modCount += 1;
    this.m_table.setInt(this.m_cur, paramString, paramInt);
  }
  
  public final boolean canGetLong(String paramString)
  {
    return this.m_table.canGetLong(paramString);
  }
  
  public final boolean canSetLong(String paramString)
  {
    return this.m_table.canSetLong(paramString);
  }
  
  public final long getLong(String paramString)
  {
    return this.m_table.getLong(this.m_cur, paramString);
  }
  
  public final void setLong(String paramString, long paramLong)
  {
    this.m_modCount += 1;
    this.m_table.setLong(this.m_cur, paramString, paramLong);
  }
  
  public final boolean canGetFloat(String paramString)
  {
    return this.m_table.canGetFloat(paramString);
  }
  
  public final boolean canSetFloat(String paramString)
  {
    return this.m_table.canSetFloat(paramString);
  }
  
  public final float getFloat(String paramString)
  {
    return this.m_table.getFloat(this.m_cur, paramString);
  }
  
  public final void setFloat(String paramString, float paramFloat)
  {
    this.m_modCount += 1;
    this.m_table.setFloat(this.m_cur, paramString, paramFloat);
  }
  
  public final boolean canGetDouble(String paramString)
  {
    return this.m_table.canGetDouble(paramString);
  }
  
  public final boolean canSetDouble(String paramString)
  {
    return this.m_table.canSetDouble(paramString);
  }
  
  public final double getDouble(String paramString)
  {
    return this.m_table.getDouble(this.m_cur, paramString);
  }
  
  public final void setDouble(String paramString, double paramDouble)
  {
    this.m_modCount += 1;
    this.m_table.setDouble(this.m_cur, paramString, paramDouble);
  }
  
  public final boolean canGetBoolean(String paramString)
  {
    return this.m_table.canGetBoolean(paramString);
  }
  
  public final boolean canSetBoolean(String paramString)
  {
    return this.m_table.canSetBoolean(paramString);
  }
  
  public final boolean getBoolean(String paramString)
  {
    return this.m_table.getBoolean(this.m_cur, paramString);
  }
  
  public final void setBoolean(String paramString, boolean paramBoolean)
  {
    this.m_modCount += 1;
    this.m_table.setBoolean(this.m_cur, paramString, paramBoolean);
  }
  
  public final boolean canGetString(String paramString)
  {
    return this.m_table.canGetString(paramString);
  }
  
  public final boolean canSetString(String paramString)
  {
    return this.m_table.canSetString(paramString);
  }
  
  public final String getString(String paramString)
  {
    return this.m_table.getString(this.m_cur, paramString);
  }
  
  public final void setString(String paramString1, String paramString2)
  {
    this.m_modCount += 1;
    this.m_table.setString(this.m_cur, paramString1, paramString2);
  }
  
  public final boolean canGetDate(String paramString)
  {
    return this.m_table.canGetDate(paramString);
  }
  
  public final boolean canSetDate(String paramString)
  {
    return this.m_table.canSetDate(paramString);
  }
  
  public final Date getDate(String paramString)
  {
    return this.m_table.getDate(this.m_cur, paramString);
  }
  
  public final void setDate(String paramString, Date paramDate)
  {
    this.m_modCount += 1;
    this.m_table.setDate(this.m_cur, paramString, paramDate);
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\data\util\TableIterator.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */