package prefuse.util;

import java.awt.FontMetrics;
import java.io.IOException;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.io.StreamTokenizer;
import java.io.StringReader;
import java.io.StringWriter;
import java.lang.reflect.Array;
import java.util.Hashtable;

public class StringLib
{
  private static final String SUFFIX = "suffix";
  private static final String PREFIX = "prefix";
  private static Hashtable prefixSuffixT = new Hashtable();
  
  public static final String getArrayString(Object paramObject)
  {
    StringBuffer localStringBuffer = new StringBuffer();
    localStringBuffer.append('[');
    int i = Array.getLength(paramObject);
    for (int j = 0; j < i; j++)
    {
      if (j > 0) {
        localStringBuffer.append(", ");
      }
      localStringBuffer.append(Array.get(paramObject, j));
    }
    localStringBuffer.append(']');
    return localStringBuffer.toString();
  }
  
  public static String formatNumber(double paramDouble, int paramInt)
  {
    String str1 = String.valueOf(paramDouble);
    int i = str1.indexOf('.');
    if (i == -1) {
      return str1;
    }
    int j = str1.indexOf('E');
    int k = paramInt + (j >= 0 ? 0 : 1);
    String str2 = str1.substring(0, Math.min(i + k, str1.length()));
    if (j >= 0) {
      str2 = str2 + str1.substring(j);
    }
    return str2;
  }
  
  public static String capitalizeFirstOnly(String paramString)
  {
    if (paramString == null) {
      return null;
    }
    if (paramString.length() == 0) {
      return paramString;
    }
    StringBuffer localStringBuffer = new StringBuffer();
    char c = paramString.charAt(0);
    localStringBuffer.append(Character.toUpperCase(c));
    boolean bool = Character.isWhitespace(c);
    for (int i = 1; i < paramString.length(); i++)
    {
      c = paramString.charAt(i);
      if (Character.isWhitespace(c))
      {
        bool = true;
      }
      else if (bool)
      {
        c = Character.toUpperCase(c);
        bool = false;
      }
      else
      {
        c = Character.toLowerCase(c);
      }
      localStringBuffer.append(c);
    }
    return localStringBuffer.toString();
  }
  
  public static String getStackTrace(Throwable paramThrowable)
  {
    StringWriter localStringWriter = new StringWriter();
    PrintWriter localPrintWriter = new PrintWriter(localStringWriter);
    paramThrowable.printStackTrace(localPrintWriter);
    localPrintWriter.close();
    return localStringWriter.toString();
  }
  
  public static String abbreviate(String paramString, FontMetrics paramFontMetrics, int paramInt)
  {
    int i = 0;
    int j = 0;
    int k = 0;
    while ((k < paramInt) && (j < paramString.length()))
    {
      if (Character.isWhitespace(paramString.charAt(j))) {
        i = j;
      }
      k += paramFontMetrics.charWidth(paramString.charAt(j));
      j++;
    }
    if ((j < paramString.length()) && (i > 0)) {
      j = i;
    }
    return j > 0 ? paramString.substring(0, j) : paramString;
  }
  
  public static String abbreviateName(String paramString, FontMetrics paramFontMetrics, int paramInt)
  {
    if (paramFontMetrics.stringWidth(paramString) > paramInt) {
      paramString = abbreviateName(paramString, false);
    }
    if (paramFontMetrics.stringWidth(paramString) > paramInt) {
      paramString = abbreviateName(paramString, true);
    }
    return paramString;
  }
  
  private static String abbreviateName(String paramString, boolean paramBoolean)
  {
    StringReader localStringReader = new StringReader(paramString);
    StreamTokenizer localStreamTokenizer = new StreamTokenizer(localStringReader);
    localStreamTokenizer.wordChars(38, 38);
    localStreamTokenizer.wordChars(64, 64);
    localStreamTokenizer.wordChars(58, 58);
    localStreamTokenizer.ordinaryChar(44);
    localStreamTokenizer.ordinaryChar(45);
    String str1 = null;
    String str2 = null;
    StringBuffer localStringBuffer = new StringBuffer();
    try
    {
      for (;;)
      {
        int i = localStreamTokenizer.nextToken();
        switch (i)
        {
        case -1: 
          break;
        case 10: 
          System.err.println("warning: unexpected EOL token");
          break;
        case -2: 
          break;
        case 44: 
          break;
        case -3: 
          if (localStreamTokenizer.sval.endsWith(":"))
          {
            localStringBuffer.append(localStreamTokenizer.sval + " ");
          }
          else if (prefixSuffixT.get(localStreamTokenizer.sval.toLowerCase()) == null)
          {
            if (!paramBoolean)
            {
              if (str2 != null) {
                localStringBuffer.append(str2);
              }
              str2 = localStreamTokenizer.sval.substring(0, 1) + ". ";
            }
            str1 = localStreamTokenizer.sval;
          }
          break;
        }
      }
      localStringBuffer.append(str1);
    }
    catch (IOException localIOException)
    {
      localIOException.printStackTrace();
    }
    return localStringBuffer.toString();
  }
  
  static
  {
    prefixSuffixT.put("mr", "prefix");
    prefixSuffixT.put("mr.", "prefix");
    prefixSuffixT.put("dr", "prefix");
    prefixSuffixT.put("dr.", "prefix");
    prefixSuffixT.put("lt", "prefix");
    prefixSuffixT.put("lt.", "prefix");
    prefixSuffixT.put("gen", "prefix");
    prefixSuffixT.put("gen.", "prefix");
    prefixSuffixT.put("sgt", "prefix");
    prefixSuffixT.put("sgt.", "prefix");
    prefixSuffixT.put("cmdr", "prefix");
    prefixSuffixT.put("cmdr.", "prefix");
    prefixSuffixT.put("cpt", "prefix");
    prefixSuffixT.put("cpt.", "prefix");
    prefixSuffixT.put("ii", "suffix");
    prefixSuffixT.put("iii", "suffix");
    prefixSuffixT.put("iv", "suffix");
    prefixSuffixT.put("jr", "suffix");
    prefixSuffixT.put("jr.", "suffix");
    prefixSuffixT.put("sr", "suffix");
    prefixSuffixT.put("sr.", "suffix");
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\util\StringLib.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */