package prefuse.util.ui;

import java.awt.Container;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableModel;
import prefuse.data.Table;
import prefuse.data.event.TableListener;
import prefuse.util.StringLib;
import prefuse.util.collections.CopyOnWriteArrayList;
import prefuse.util.collections.IntIterator;
import prefuse.visual.VisualTable;

public class JPrefuseTable
  extends JTable
{
  private Table m_table;
  private TableCellRenderer m_tcr = new DefaultTableCellRenderer();
  
  public JPrefuseTable(Table paramTable)
  {
    this.m_table = paramTable;
    PrefuseTableModel localPrefuseTableModel = new PrefuseTableModel();
    super.setModel(localPrefuseTableModel);
    this.m_table.addTableListener(localPrefuseTableModel);
  }
  
  public Table getTable()
  {
    return this.m_table;
  }
  
  public TableCellRenderer getCellRenderer(int paramInt1, int paramInt2)
  {
    return this.m_tcr;
  }
  
  public static JFrame showTableWindow(Table paramTable)
  {
    JPrefuseTable localJPrefuseTable = new JPrefuseTable(paramTable);
    String str = paramTable.toString();
    if ((paramTable instanceof VisualTable)) {
      str = ((VisualTable)paramTable).getGroup() + " " + str;
    }
    JFrame localJFrame = new JFrame(str);
    localJFrame.getContentPane().add(new JScrollPane(localJPrefuseTable));
    localJFrame.pack();
    localJFrame.setVisible(true);
    return localJFrame;
  }
  
  public class PrefuseTableModel
    implements TableModel, TableListener
  {
    private CopyOnWriteArrayList m_listeners = new CopyOnWriteArrayList();
    private int[] m_rowmap;
    
    public PrefuseTableModel() {}
    
    private void initRowMap()
    {
      this.m_rowmap = new int[JPrefuseTable.this.m_table.getRowCount()];
      IntIterator localIntIterator = JPrefuseTable.this.m_table.rows();
      for (int i = 0; localIntIterator.hasNext(); i++) {
        this.m_rowmap[i] = localIntIterator.nextInt();
      }
    }
    
    private int getRow(int paramInt)
    {
      if (this.m_rowmap == null) {
        initRowMap();
      }
      return this.m_rowmap[paramInt];
    }
    
    public int getColumnCount()
    {
      return JPrefuseTable.this.m_table.getColumnCount();
    }
    
    public int getRowCount()
    {
      return JPrefuseTable.this.m_table.getRowCount();
    }
    
    public boolean isCellEditable(int paramInt1, int paramInt2)
    {
      return JPrefuseTable.this.m_table.isCellEditable(paramInt1, paramInt2);
    }
    
    public Class getColumnClass(int paramInt)
    {
      return JPrefuseTable.this.m_table.getColumnType(paramInt);
    }
    
    public Object getValueAt(int paramInt1, int paramInt2)
    {
      Object localObject = JPrefuseTable.this.m_table.getValueAt(getRow(paramInt1), paramInt2);
      if ((localObject != null) && (localObject.getClass().isArray())) {
        return StringLib.getArrayString(localObject);
      }
      return localObject;
    }
    
    public void setValueAt(Object paramObject, int paramInt1, int paramInt2)
    {
      JPrefuseTable.this.m_table.setValueAt(getRow(paramInt1), paramInt2, paramObject);
    }
    
    public String getColumnName(int paramInt)
    {
      return JPrefuseTable.this.m_table.getColumnName(paramInt);
    }
    
    public void addTableModelListener(TableModelListener paramTableModelListener)
    {
      this.m_listeners.add(paramTableModelListener);
    }
    
    public void removeTableModelListener(TableModelListener paramTableModelListener)
    {
      this.m_listeners.remove(paramTableModelListener);
    }
    
    public void tableChanged(Table paramTable, int paramInt1, int paramInt2, int paramInt3, int paramInt4)
    {
      if ((paramInt4 == 1) || (paramInt4 == -1)) {
        this.m_rowmap = null;
      }
      Object[] arrayOfObject = this.m_listeners.getArray();
      if (arrayOfObject.length == 0) {
        return;
      }
      TableModelEvent localTableModelEvent = new TableModelEvent(this, paramInt1, paramInt2, paramInt3, paramInt4);
      for (int i = 0; i < arrayOfObject.length; i++) {
        ((TableModelListener)arrayOfObject[i]).tableChanged(localTableModelEvent);
      }
    }
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\util\ui\JPrefuseTable.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */